#!/usr/bin/perl
# rjamet, around july 2012
# Script to launch a campaign of simulations in Sinalgo
#
# First option : number of processes to run at the same time


use Runner::Utils qw/run_many/;
use Runner::Config qw/gen_nodes init_nodes/;
use Cwd; #for getcwd

$GRAPH_DIR=getcwd."/graphs";


$RUNS="-r 1";

# The project Sinalgo will use the config.xml from
$PROJECT=" -p TLCNS ";

# Number of messages to run
$NB_MSG="Messages/Number=".200_000;

#TLCNS settings
$ACK_SIZE = 5; $RET_SIZE = 3; $ROUTE_SIZE = 10; 
$TLCNS_OPT = 
" counter/rolling=true counter/rollingsize=".($ROUTE_SIZE*64). 
" ack/enable=true ack/tl/type=list ack/tl/size=".($ACK_SIZE*64). 
" tl/type=list tl/shared=true tl/size=".($RET_SIZE*64);


#@graphs runs first (graph gen), and waits until everything's done to run @commands
my @graphs;
my @commands;


#The parameters which vary
for my $pctA (5) {
	for my $NBNODES (200) {
		for my $DEGREE (16) {

	#number of attackers
	my $nbA = $pctA * $NBNODES / 100;

	#Area of simulation, seed & graph/degree stuff
	my $seed = " useFixedSeed=true fixedSeed=0 ";
	my $AREA_SIDE = int sqrt(($NBNODES*3.14*20*20) / $DEGREE);
	my $LAMBDA = sqrt($DEGREE) / (10 * $NBNODES);
	my $SETTINGS=" UDG/rMax=20 dimX=$AREA_SIDE dimY=$AREA_SIDE $seed sender/lambda=$LAMBDA $NB_MSG";

	init_nodes("$GRAPH_DIR/udg_${NBNODES}_20_${AREA_SIDE}/");
	my %nbnodes;

	#If needed, add the graph generation jobs to @graphs
      # if (! -e "./graphs/udg_${NBNODES}_20_${AREA_SIDE}/") {
       
       			#bypass commands here, I'm not sure about dependancies
               system "cd graphs && ./campaignmaker.pl $NBNODES 20 $AREA_SIDE";
               mkdir "./graphs/udg_${NBNODES}_20_${AREA_SIDE}/";
               mkdir "./graphs/holeyudg1_${NBNODES}_20_${AREA_SIDE}/";
               mkdir "./graphs/holeyudg2_${NBNODES}_20_${AREA_SIDE}/";
 			   for(0..99) {
 			   	   system
                       "cd graphs && ./holeymaker.pl 1 20 "
                       .($NBNODES-$nbA)." ./udg_${NBNODES}_20_${AREA_SIDE}/$_.pos "
                       .$nbA . " ./revudg_${NBNODES}_20_${AREA_SIDE}/$_.pos "
                       ." ./holeyudg1_${NBNODES}_20_${AREA_SIDE}/H$_.pos "
                       ." ./holeyudg1_${NBNODES}_20_${AREA_SIDE}/A$_.pos ";

                    $nbnodes{"1H$_"} = `wc -l  ./graphs/holeyudg1_${NBNODES}_20_${AREA_SIDE}/H$_.pos` - 2;
					$nbnodes{"1A$_"} = `wc -l  ./graphs/holeyudg1_${NBNODES}_20_${AREA_SIDE}/A$_.pos` - 2;

 			   	   system
                       "cd graphs && ./holeymaker.pl 2 20 "
                       .($NBNODES-$nbA)." ./udg_${NBNODES}_20_${AREA_SIDE}/$_.pos "
                       .$nbA . " ./revudg_${NBNODES}_20_${AREA_SIDE}/$_.pos "
                       ." ./holeyudg2_${NBNODES}_20_${AREA_SIDE}/H$_.pos "
                       ." ./holeyudg2_${NBNODES}_20_${AREA_SIDE}/A$_.pos ";

					$nbnodes{"2H$_"} = `wc -l  ./graphs/holeyudg2_${NBNODES}_20_${AREA_SIDE}/H$_.pos` - 2;
					$nbnodes{"2A$_"} = `wc -l  ./graphs/holeyudg2_${NBNODES}_20_${AREA_SIDE}/A$_.pos` - 2;


               }



     #  }


	#Sinalgo command g




for(0..49) {

	my $GN = " -gen 1 AckingSinkNode Center ".
"-gen ". $nbnodes{"1H$_"} . " TLCNS:TLCNSNode ".
"PositionFile \\(/home/rjamet/Work/Code/sinalgo/runnerv3/graphs/holeyudg1".
"_200_20_125/H${_}.pos\\) ".
"-gen ". $nbnodes{"1A$_"} . " BlackholeNode ".
"PositionFile \\(/home/rjamet/Work/Code/sinalgo/runnerv3/graphs/holeyudg1".
"_200_20_125/A${_}.pos\\) ";


	push @commands, 
		"perl runner.pl $PROJECT -n \"HOLE1-BH-SR3_${NBNODES}_${DEGREE}_".$pctA."pct_g${_}\" $RUNS ".
		" -N \"".$GN." \" -a \"$SETTINGS $TLCNS_OPT\" ";



 $GN =  " -gen 1 AckingSinkNode Center ".
"-gen ". $nbnodes{"1H$_"} . " TLCNS:TLCNSNode ".
"PositionFile \\(/home/rjamet/Work/Code/sinalgo/runnerv3/graphs/holeyudg1".
"_200_20_125/H${_}.pos\\) ";

	push @commands, 
		"perl runner.pl $PROJECT -n \"HOLE1-HOLE-SR3_${NBNODES}_${DEGREE}_".$pctA."pct_g${_}\" $RUNS ".
		" -N \"".$GN." \" -a \"$SETTINGS $TLCNS_OPT\" ";


 $GN =  " -gen 1 AckingSinkNode Center ".
"-gen ". $nbnodes{"2H$_"} . " TLCNS:TLCNSNode ".
"PositionFile \\(/home/rjamet/Work/Code/sinalgo/runnerv3/graphs/holeyudg2".
"_200_20_125/H${_}.pos\\) ".
"-gen ". $nbnodes{"2A$_"} . " BlackholeNode ".
"PositionFile \\(/home/rjamet/Work/Code/sinalgo/runnerv3/graphs/holeyudg2".
"_200_20_125/A${_}.pos\\) ";

	push @commands, 
		"perl runner.pl $PROJECT -n \"HOLE2-BH-SR3_${NBNODES}_${DEGREE}_".$pctA."pct_g${_}\" $RUNS ".
		" -N \"".$GN." \" -a \"$SETTINGS $TLCNS_OPT\" ";


 $GN =  " -gen 1 AckingSinkNode Center ".
"-gen ". $nbnodes{"2H$_"} . " TLCNS:TLCNSNode ".
"PositionFile \\(/home/rjamet/Work/Code/sinalgo/runnerv3/graphs/holeyudg2".
"_200_20_125/H${_}.pos\\) ";


	push @commands, 
		"perl runner.pl $PROJECT -n \"HOLE2-HOLE-SR3_${NBNODES}_${DEGREE}_".$pctA."pct_g${_}\" $RUNS ".
		" -N \"".$GN." \" -a \"$SETTINGS $TLCNS_OPT\" ";
}
}
}
}



run_many(@graphs);


run_many(@commands);

#print join "\n",@commands;

`echo "Hello from the imps in \$HOSTNAME. Sinalgo campaign is over." | mailx -s "Sinalgo finish notification" jamet.raphael\@gmail.com`;

#End !
