#!/usr/bin/perl
use strict;
use warnings;
use Carp qw/confess/; 
use List::Util qw/ min /;

#Makes a graph with holes.

sub usage() {
	confess("usage : holeymaker.pl [distance] [udgrad] [nbnodes] [fileHonest.pos] [nbnodes] [fileAttackers.pos] [OutFileHonest.pos] [OutFileAttacked.pos]\n" );
	die();
}


my $killhops = shift or usage(); #Killing range in hops
my $commrange = shift or usage();; #comm range in distance units
my $nbH = shift or usage();
open(my $fileH, shift) or usage(); #name of the honest nodes file
my $nbA = shift  or usage();
open(my $fileA, shift)  or usage(); # ... attackers...

open(my $OfileH, ">".shift )  or usage(); #honest output file
open(my $OfileA, ">".shift )  or usage(); # ... attackers...


sub near {
	my $a = shift or die; 
	my $b = shift or die;
	return (($a->[0] - $b->[0])**2 + ($a->[1] - $b->[1])**2) <= $commrange**2;
}

my @posH; my @posA; 

#killed
my @posK = ();
#still honest
my @posSH = ();


#get all honest nodes
while(<$fileH>) {
	if (/(\d+\.\d+)[\s,]+(\d+\.\d+)[\s,]+0/) {
		#node
		push @posH, [$1,$2]; 
		last unless --$nbH;
	}
}

#get attackers
while(<$fileA>) {
	if (/(\d+\.\d+)[\s,]+(\d+\.\d+)[\s,]+0/) {
		#node
		push @posA, [$1,$2]; 
		last unless --$nbA;
	}
}

#Sort honest nodes near attackers
for my $honest (@posH) {
	if (!(grep {near($_,$honest)} @posA)) {
		push @posSH, $honest; 
	} else {
		push @posK, $honest; 
	}
}

if ($killhops == 2) {
	@posH = @posSH; @posSH = ();
	my @posK2 = ();
	for my $honest (@posH) {
		if (!(grep {near($_,$honest)} (@posA,@posK))) {
			push @posSH, $honest; print $honest." ok \n";
		} else {
			push @posK2, $honest; print $honest." killed \n";
		}
	}
	@posK = (@posK, @posK2);
}

my $dumbString = "Number of nodes: 12345\n#####----- start of node posiitons -----#####\n";



print $OfileH $dumbString;
print $OfileA $dumbString;

print $OfileH $_->[0]." , ".$_->[1]." , 0\n" for @posSH;
print $OfileA $_->[0]." , ".$_->[1]." , 0\n" for @posK;