use strict;
use warnings;
use Carp qw/confess/; 
use List::Util qw/ min /;

sub usage() {
	confess("usage : maker.pl [nb_noeuds] [udg_radius] [square_side]" );
	return;
}


my $nb = shift or usage();
my $udgrad = shift or usage();
my $side = shift or usage();


my $tried = 0;
my @nx; #grand tableau des coordonnees x
my @ny; #y

my @visited; #noeuds explores
my @tovisit; #liste de noeuds a explorer

my %neigh; 



sub connected { 
	my $na = shift;
	my $nb = shift;
	my $nx = shift;
	my $ny = shift;
	return (sqrt(
			(($ny->[$na])-($ny->[$nb]))**2 + 
			(($nx->[$na])-($nx->[$nb]))**2
					) < $udgrad)?1:0;
}

sub allconnected {
	my @tovisit;
	my @visited= (0)x$nb;

	push @tovisit, 1;
	while(1) { #verif connecte
		if (!@tovisit) {last};
		my $cur = pop @tovisit;
		if ($visited[$cur]) {next;}
		$visited[$cur] = 1;
		for my $other (0..$nb-1) {
			if ($neigh{"$cur,$other"} == 1) {
				push @tovisit, $other;
			} 
		}
	}
	if (! grep /0/, @visited) { 
		return 1; #tous connectes
	}
	return 0;
}

# Connectedness for 70%, 80%, 90% of the nodes
sub allconnected_idmax {
	my @tovisit;
	my $idmax = shift or die("Specify a maximal id");
	my @visited = (0) x $idmax;
	push @tovisit, 1;
	while(1) { #verif connexite
		if (!@tovisit) {last};
		my $cur = pop @tovisit;
		if ($visited[$cur]) {next;}
		$visited[$cur] = 1;
		for my $other (0..min($nb-1, $idmax-1)) {
			if ($neigh{"$cur,$other"} == 1) {
				push @tovisit, $other;
			} 
		}
	}
	if (! grep {$_==0} @visited[0..min($nb-1, $idmax-1)]) { 
		return 1; #tous connectes
	}
	return 0;
}


while(1) { 
	$tried += 1;
	print STDERR "Try $tried\n";
	@nx=(); 
	@ny=(); 
	@visited=(); 
	@tovisit=();

	%neigh = (); 
	
	for (0..$nb-1) {
		push @nx, rand($side); #Taille de l'aire de simu (a changer ?)
		push @ny, rand($side);
		push @visited, 0;
	}
	for my $cur (0..$nb-1) {
		for ($cur..$nb-1) {
			$neigh{"$_,$cur"} = $neigh{"$cur,$_"} = connected($cur,$_,\@nx,\@ny)
		}
	}

	if (allconnected()) { 
		last; #tous connects
	}
}

print "Number of nodes: $nb\n";
print "#####----- start of node posiitons -----#####\n"; #LA FAUTE EST NECESSAIRE
for (0..$nb-1) {
	printf('%5.3f , %5.3f, 0'."\n", $nx[$_], $ny[$_]);
}


