#!/usr/bin/perl

use Parallel::ForkManager;
my $nb_proc = shift;
my $pm = new Parallel::ForkManager($nb_proc);

sub red {
  print "\033[33m";
 	print(shift);
  print "\033[0m";
}

sub gen_nodes {
	my $r = "";
	while(@_) {
		my $nb = shift;
		my $cmd = shift;
		$r .= "-gen $nb $cmd " unless ($nb <= 0);
	}
	return " \"$r\" ";
}


$GRAPH_DIR="/home/rjamet/simus/sinalgo/runnerv3/graphs";
 
$RUNS="-r 1";
$PROJECT=" -p TLCNS ";

$GEN_A_TLCNS_SINK="AckingSinkNode Center ";
$GEN_A_GBR_SINK="GBR:GBRSink Center ";
$GEN_A_SINK="SinkNode Center ";

#$GEN_RAND_TLCNS="TLCNS:TLCNSNode PositionFile \\($GRAPH_DIR/n_random/\\\$RUN.pos\\) ";
#$GEN_RAND_GREEDY="Greedy:GreedyNode PositionFile \\($GRAPH_DIR/n_random/\\\$RUN.pos\\) ";
#$GEN_RAND_RW="RW:RWNode PositionFile \\($GRAPH_DIR/n_random/\\\$RUN.pos\\) ";
#$GEN_RAND_GBR="GBR:GBRNode PositionFile \\($GRAPH_DIR/n_random/\\\$RUN.pos\\) ";
#$GEN_RAND_CNBACKWARD="CNBackward:CNBackwardNode PositionFile \\($GRAPH_DIR/n_random/\\\$RUN.pos\\) ";
#$GEN_CENTERED_BH="BlackholeNode PositionFile \\($GRAPH_DIR/bh_centered/\\\$RUN.pos\\) ";
#$GEN_RAND_BH="BlackholeNode PositionFile \\($GRAPH_DIR/bh_random/\\\$RUN.pos\\) ";
#$GEN_RAND_SF="SelectiveForwardingNode PositionFile \\($GRAPH_DIR/bh_random/\\\$RUN.pos\\) ";
#$GEN_RAND_FBR="FBR:FBRNode PositionFile \\($GRAPH_DIR/n_random/\\\$RUN.pos\\) ";
#$GEN_RAND_GFG="FBR:GFGNode PositionFile \\($GRAPH_DIR/n_random/\\\$RUN.pos\\) ";

$NB_MSG="Messages/Number=20000";

$CLASSIC=" ack/enable=false counter/rolling=false tl/type=list tl/size=512 tl/shared=true ";



my @commands;

my $seed = 0;
my $nbA = 0;

my $DEGREE = 12;
my $UDGR = 20;
my $MESSAGES_PER_TIME_UNIT = 5;

for my $NBNODES (100,200,400) {

for my $DEGREE (8,16,32) {

my $AREA_SIDE = int sqrt(($NBNODES*3.14*$UDGR*$UDGR) / $DEGREE);

$FIELD_SETTINGS=" UDG/rMax=$UDGR dimX=$AREA_SIDE dimY=$AREA_SIDE useFixedSeed=true sender/lambda=".(0.01*$MESSAGES_PER_TIME_UNIT / $NBNODES);

#$TL= " ack/enable=true ack/tl/type=list ack/tl/size=".($ACKTLSIZE * 64)." tl/type=list tl/size=".(64*$RETURNTLSIZE)." tl/shared=true ";
#$ROLL = " $TL counter/rolling=true ";

push @commands, 
	"timeout 7200 perl runner.pl $PROJECT -n \"RW${NBNODES}_${DEGREE}_RW\" $RUNS ".
	"-N ".gen_nodes(1," SinkNode Center ",$NBNODES-$nbA, "RW:RWNode ConnectedUDG ", $nbA, "BlackholeNode Random").
	"-a \" $NB_MSG $FIELD_SETTINGS $ROLL fixedSeed=$seed \"";

}

}

for (@commands) {
	if($pm->start) {
			next;
	} else {
			red "Running $_ : \n";
			system $_."\n";
			sleep(1);
	}
	$pm->finish;
}
$pm->wait_all_children();
