package projects.CASTOR.behaviour;

import java.util.Map;
import java.util.Set;

import projects.CASTOR.messages.CastorAckMessage;
import projects.CASTOR.nodes.nodeImplementations.CastorNode;
import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import sinalgo.nodes.edges.Edge;

public class CastorAckBehaviour implements Behaviour {

	CastorNode puppet;

	@Override
	public void init(BasicNode puppet) {
		assert(puppet instanceof CastorNode):"Should only be used with CastorNodes";
		this.puppet = (CastorNode) puppet;
	}

	

	@Override
	public void act(BasicMessage m) {
		assert(m instanceof CastorAckMessage):"Bad message type";
		CastorAckMessage cam = (CastorAckMessage) m;

		//Manage reputation first, routing after
		for (Edge e : puppet.getConnections()) {
			Set<Integer> reputation = puppet.ackReputationMap.get(e);
			if (reputation.contains(cam.ackID)) {
				puppet.reputations.get(e).get(cam.flowID).updateReputation(true, false);
			}
			reputation.remove(cam.ackID);
		}		

		//routing
		if (puppet == cam.destination) {//hackish
			if(puppet.ackRoutingMap.containsKey(cam.ackID)) { 
			//	System.out.println("Castor node "+puppet.ID+" received its ack m "+cam.idMessage);
				puppet.eatMessage(cam, BasicMessage.Status.OK);
			} else {
			//	System.out.println("Castor node "+puppet.ID+" received a duplicate ack m "+cam.idMessage);
				puppet.eatMessage(cam, BasicMessage.Status.TTL);
			}
		} else {
			if(puppet.ackRoutingMap.containsKey(cam.ackID)) { 
				BasicNode dest = puppet.ackRoutingMap.get(cam.ackID);			
				
				cam.hopto(puppet,dest);
				puppet.send(cam, dest);
				puppet.ackRoutingMap.remove(cam.ackID);
			//	System.out.println("Castor node "+puppet.ID+" forwards ack m "+cam.idMessage +" to "+dest.ID);
			} else {
				//System.out.println("Castor node "+puppet.ID+" forgot who to send ack"+cam.idMessage +" to");
				puppet.eatMessage(cam, BasicMessage.Status.TTL);
			}
		}
	}
	
	
	

}
