package projects.CASTOR.behaviour;

import java.util.Set;
import java.util.TreeSet;

import projects.CASTOR.messages.CastorAckMessage;
import projects.CASTOR.messages.CastorMessage;
import projects.CASTOR.nodes.nodeImplementations.CastorAckingSinkNode;
import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.utils.Tools;
import sinalgo.runtime.Global;

public class CastorSinkBehaviour implements Behaviour {

	CastorAckingSinkNode puppet;

	public Set<Integer> received = new TreeSet<Integer>();

	@Override
	public void init(BasicNode puppet) {
		assert (puppet instanceof CastorAckingSinkNode) : "Should only be used with CastorNodes";
		this.puppet = (CastorAckingSinkNode) puppet;
	}

	@Override
	public void act(BasicMessage m) {
		// assert ((m.destination == null && puppet.isSink()) ||
		// m.destination.equals(puppet)) :
		// "Message probably not intended for this node";

		assert (m instanceof CastorMessage) : "Should only receive castormessages";


		int identifierAck;
		if (CastorAckMessage.idToAckMap.containsKey(m.idMessage)) {
			identifierAck = CastorAckMessage.idToAckMap.get(m.idMessage);
			BasicMessage.duplicatas.put(identifierAck,
					BasicMessage.duplicatas.get(identifierAck)+1);
		} else {
			identifierAck = Tools.generateID();
			CastorAckMessage.idToAckMap.put(m.idMessage, identifierAck);
		}


		
		
		puppet.send(new CastorAckMessage((CastorMessage) m, puppet,
				Global.currentTime, identifierAck), m.lastNode);

		

		if (received.contains(m.idMessage)) {
			puppet.eatMessage(m, BasicMessage.Status.TTL);
		} else {
			puppet.eatMessage(m, BasicMessage.Status.OK);
			received.add(m.idMessage);
		}
		// System.out.println("Castor sink "+puppet.ID+" received m "+m.idMessage
		// +" and answers ack"+identifierAck);

	}

}
