package projects.CASTOR.messages;

import java.util.Map;
import java.util.TreeMap;

import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.utils.Tools;
import sinalgo.nodes.messages.Message;

public class CastorAckMessage extends BasicMessage {

	public int flowID;
	public int ackID;

	public static Map<Integer, Integer> idToAckMap = new TreeMap<Integer, Integer>();

	public CastorAckMessage(CastorMessage cm, BasicNode lastNode,
			double timeBegin, int idMessage) {

		super(cm.destination, lastNode, 0, timeBegin, idMessage, cm.sender);
	
		this.flowID = cm.flowID;
		this.ackID = cm.idMessage;
	}

	public CastorAckMessage(CastorAckMessage cam) {
		super(cam.sender, cam.lastNode, cam.hops, cam.timeBegin, cam.idMessage,
				cam.destination);
		this.flowID = cam.flowID;
		this.ackID = cam.ackID;
	}

	@Override
	public Message clone() {
		return new CastorAckMessage(this);
	}

	@Override
	public String toJSON() {
		String st = "";

		st += ("{");
		st += ("\"id\":" + this.idMessage + ",");
		st += ("\"type\":\"ack\",");
		st += ("\"h\":" + this.hops + ",");
		st += ("\"tb\":" + Tools.tojson(this.timeBegin) + ",");
		st += ("\"te\":" + Tools.tojson(this.timeEnd) + ",");

		if (sender != null) {// TODO: everywhere
			st += ("\"f\":" + this.sender.ID + ",");
		} else {
			st += ("\"f\": -1,");
		}
		st += ("\"d\":" + this.st + ",");
		st += ("\"o\":-1,");// TODO : fix
		st += ("\"ackid\":"+this.ackID+",");

		if (destination != null) {
			st += ("\"t\":" + this.destination.ID);
		} else {
			st += ("\"t\":-1");
		}

		st += ("}");
		return st;
	}

}
