package projects.CASTOR.messages;

import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.utils.Tools;
import sinalgo.nodes.messages.Message;



public class CastorMessage extends BasicMessage {

	public int flowID;
	

	public CastorMessage(BasicNode sender, BasicNode lastNode, int hops, double timeBegin,
			int idMessage, BasicNode dest, int flowID) {
		super(sender,lastNode,hops,timeBegin,idMessage,dest);
		this.flowID=flowID;
	}

	@Override
	public Message clone() {
		return new CastorMessage(sender, lastNode, hops, timeBegin, idMessage, destination, flowID);
	}
	
	@Override
	public String toJSON() {
		String st = "";

		st += ("{");
		st += ("\"id\":" + this.idMessage + ",");
		st += ("\"type\":\"basic\",");
		st += ("\"h\":" + this.hops + ",");
		st += ("\"tb\":" + Tools.tojson(this.timeBegin) + ",");
		st += ("\"te\":" + Tools.tojson(this.timeEnd) + ",");
		st += ("\"f\":" + this.sender.ID + ",");
		st += ("\"d\":" + this.st + ",");
		st += ("\"o\":" + Tools.tojson(this.hops / (double)this.sender.distanceToSink) + ",");

		if (destination != null) {
			st += ("\"t\":" + this.destination.ID);
		} else {
			st += ("\"t\":-1");
		}

		st += ("}");
		return st;
	}

}
