package projects.CASTOR.timers;

import projects.CASTOR.messages.CastorMessage;
import projects.CASTOR.nodes.nodeImplementations.CastorNode;
import projects.common.nodes.BasicNode;
import sinalgo.nodes.edges.Edge;
import sinalgo.nodes.timers.Timer;

/**
 * Same as SenderTimer, except it sends CastorMessages
 * @author rjamet
 *
 */
public class CastorExpirationTimer extends Timer {

	CastorNode puppet;
	CastorMessage targetMessage;
	
	public CastorExpirationTimer(BasicNode puppet, CastorMessage cm) {
		super();
		assert(puppet instanceof CastorNode);
		this.puppet = (CastorNode) puppet;
		targetMessage = cm;
	}
	
	@Override
	public void fire() {
		for (Edge e : puppet.getConnections()) {
			puppet.reputations.get(e).get(targetMessage.flowID).updateReputation(false, false);
			puppet.ackReputationMap.get(e).remove(targetMessage.idMessage);
		}
		puppet.ackRoutingMap.remove(targetMessage.idMessage);
	}
	
}
