package projects.CNBackward.behaviour;

import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.nodes.BasicTabuNode;
import sinalgo.nodes.edges.Edge;

public class CNBackRouter implements Behaviour {

	BasicTabuNode puppet;
	
	@Override
	public void init(BasicNode n) {
		if (n instanceof BasicTabuNode) {
			this.puppet = (BasicTabuNode) n;
		} else {
			throw new RuntimeException("CNBackRouter needs a BasicTabuNode");
		}
	}
	

	@Override
	public void act(BasicMessage m) {
		
		for (Edge e2 : puppet.getConnections()) {
			if (puppet.counters.get(e2) == null) {
				puppet.initCheck(e2);
			}
			if (e2.endNode.equals(m.lastNode)) {
				puppet.counters.put(
						e2,(1/(1/puppet.counters.get(e2)+1))
				);
			}
		}
		
		Edge next = puppet.select(m);
		m.hopto(next);
		puppet.send(m, next.endNode);
		
	}
	
	

}
