package projects.CNBackward.nodes.nodeImplementations;

import projects.CNBackward.behaviour.CNBackRouter;

import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.nodes.BasicTabuNode;
import projects.common.selector.AlwaysSelector;

/**
 * CNBackward is a node which maintains counters for each neighbors, which
 * are incremented by one when receiving a message from the corresponding neighbor.
 * Higher counters means lower probability of routing to that node. Antoine's
 * idea
 *  
 * @author rjamet
 * 
 */
public class CNBackwardNode extends BasicTabuNode {

	@Override
	public void init() {
		super.init();
		rb = new RoutingBehaviour(this).add(new AlwaysSelector(),
				new CNBackRouter());
	}

}