package projects.CNForward.nodes.nodeImplementations;


import projects.CNForward.behaviour.CNForwardRouter;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.nodes.BasicTabuNode;
import projects.common.selector.AlwaysSelector;

/**
 * CNForwardNode is a node which maintains counters for each
 * neighbors, which are incremented by one when sending a message
 * to the corresponding neighbor. Higher counters means lower
 * probability of routing to that node. Antoine's random idea.
 * 
 * @author rjamet
 * 
 */
public class CNForwardNode extends BasicTabuNode {

	@Override
	public void init() { 
			rb = new RoutingBehaviour(this).
			add(new AlwaysSelector(), new CNForwardRouter());
	}
}