package projects.FBR.behaviour;

import projects.FBR.messages.FBRMessage;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.selector.Selector;
import sinalgo.nodes.edges.Edge;

public class GFGSelector implements Selector {

	BasicNode puppet;
	
	@Override
	public boolean activate(BasicMessage m) {
		boolean FBR = ((FBRMessage) m).GFGSwitchDistance > 0;

		if (FBR) {
			if (puppet.getPosition().distanceTo(BasicNode.sinkPos) < ((FBRMessage) m).GFGSwitchDistance) {
				((FBRMessage) m).GFGSwitchDistance = -1;
				return true;
			} else {
				return false;
			}
		} else {
			for(Edge e : puppet.getConnections()) {
				if (e.endNode.getPosition().distanceTo(BasicNode.sinkPos) < 
						puppet.getPosition().distanceTo(BasicNode.sinkPos)) {
					return true;
				}
			}
			((FBRMessage) m).GFGSwitchDistance = puppet.getPosition().distanceTo(BasicNode.sinkPos) ;
			((FBRMessage) m).FBRRoutingReset(puppet);
			return false;
		}
	}

	@Override
	public void init() {
			//vide
	}
	
	public GFGSelector(BasicNode puppet) {
		this.puppet = puppet;
	}

}
