package projects.FBR.nodes.nodeImplementations;

import projects.FBR.behaviour.FBRRouter;
import projects.FBR.timers.FBRSenderTimer;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.nodes.BasicNode;
import projects.common.selector.AlwaysSelector;
import projects.common.utils.Tools;
import sinalgo.nodes.messages.Message;
/**
 * GreedyNode is a node which redirects messages to the neighbor
 * closest to the sink. It is as dumb as possible : multilple sinks
 * will default to the latest one registered, no hole bypassing mechanism
 * and no fancy stuff. Will lock up if there is a hole.
 * @author rjamet
 *
 */
public class FBRNode extends BasicNode {

	public static boolean planarized = false;
	
	@Override
	public void init() {
		rb = new RoutingBehaviour(this).
				add(new AlwaysSelector(), new FBRRouter());
		super.init();
	}

	@Override
	protected void action(Message msg_receive) {
		if (!planarized) {
			planarized = true;
			Tools.buildBlacklistPlanarize();
		}
		super.action(msg_receive);
	}
	@Override
	protected void startTimers() {
		if (!isSink()) {
			(new FBRSenderTimer(this)).startRelative(1, this);
		} else {
			super.startTimers();
		}
	}
	

}
