package projects.FBR.nodes.nodeImplementations;

import projects.FBR.behaviour.FBRRouter;
import projects.FBR.behaviour.GFGSelector;
import projects.Greedy.behaviour.GreedyRouter;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.selector.AlwaysSelector;
/**
 * GreedyNode is a node which redirects messages to the neighbor
 * closest to the sink. It is as dumb as possible : multilple sinks
 * will default to the latest one registered, no hole bypassing mechanism
 * and no fancy stuff. Will lock up if there is a hole.
 * @author rjamet
 *
 */
public class GFGNode extends FBRNode {

	public static boolean planarized = false;
	
	@Override
	public void init() {
		super.init();
		rb = new RoutingBehaviour(this).
				add(new GFGSelector(this), new GreedyRouter()).
				add(new AlwaysSelector(), new FBRRouter());
	}
}
