package projects.FBR.nodes.nodeImplementations;

import projects.FBR.behaviour.FBRRouter;
import projects.FBR.behaviour.GFGSelector;
import projects.Greedy.behaviour.GreedyRouter;
import projects.RW.nodes.nodeImplementations.SFThenRWNode;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.ProbabilitySelector;
/**
 * GreedyNode is a node which redirects messages to the neighbor
 * closest to the sink. It is as dumb as possible : multilple sinks
 * will default to the latest one registered, no hole bypassing mechanism
 * and no fancy stuff. Will lock up if there is a hole.
 * @author rjamet
 *
 */
public class SFThenGFGNode extends GFGNode {

	@Override
	public boolean sendsMessages() {
		return false;
	}

	@Override
	public void JSONOutput() {
		System.out.println("{\"t\":\"blackhole\", \"id\":" + ID + ", \"d\":"
				+ this.outgoingConnections.size() + "," + JSONNeighbors()
				+ "},");
	}

	@Override
	public void init() {
		super.init();
		rb = new RoutingBehaviour(this).
				add(new ProbabilitySelector(SFThenRWNode.interceptProbability),
						new BlackholeBehaviour()).
				add(new GFGSelector(this), new GreedyRouter()).
				add(new AlwaysSelector(), new FBRRouter());
	}
}
