package projects.GBR.behaviour;

import java.util.Map;

import projects.GBR.messages.GBRMessage;
import projects.GBR.nodes.nodeImplementations.GBRNode;
import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.messages.BasicMessage.Status;
import projects.common.nodes.BasicNode;
import sinalgo.nodes.edges.Edge;

public class GBRBuilder implements Behaviour {

	GBRNode puppet;
	Map<BasicNode, Integer> map;

	@Override
	public void init(BasicNode puppet) {
		assert(puppet instanceof GBRNode );
		this.puppet = (GBRNode) puppet;
	}
/**
 * 
 * @param distances can be null
 * @param min_distance
 */
	public GBRBuilder(Map<BasicNode, Integer> distances) {
		this.map = distances;
	}

	@Override
	public void act(BasicMessage m) {
		 assert (m instanceof GBRMessage) :
		 "This should only route GBR building messages";
		GBRMessage bm = (GBRMessage) m;

		if (map != null) {
			if ((map.get(bm.lastNode) != null && bm.hops < map.get(bm.lastNode))
					|| map.get(bm.lastNode) == null) {
				map.put(bm.lastNode, bm.hops);
			}
		}
		
		puppet.eatMessage(bm, Status.DONOTLOG);

		if (bm.hops < puppet.getMinDist()) {
			puppet.setMinDist(bm.hops);

			for (Edge e : puppet.getConnections()) {
				if (map != null) {
					if (map.get(e.endNode) != null) {
						map.put((BasicNode) e.endNode,
								Math.min(puppet.getMinDist() + 2, map.get(e.endNode)));
					} else {
						map.put((BasicNode) e.endNode, puppet.getMinDist() + 2);
					}
				}
				GBRMessage mc = (GBRMessage) bm.clone();
				mc.hopto(e);
				puppet.send(mc, e.endNode);
			}
		}
	}

}
