package projects.GBR.behaviour;

import java.util.Map;

import projects.GBR.messages.GBRMessage;
import projects.GBR.nodes.nodeImplementations.GBRNode;
import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import sinalgo.runtime.Global;

public class GBRLowerLevelFirstRouter implements Behaviour {

	GBRNode puppet;
	Map<BasicNode, Integer> map;

	@Override
	public void init(BasicNode puppet) {
		assert(puppet instanceof GBRNode);
		this.puppet = (GBRNode) puppet;
	}


	public GBRLowerLevelFirstRouter(Map<BasicNode, Integer> distances) {
		this.map = distances;
	}

	@Override
	public void act(BasicMessage m) {
		assert (!(m instanceof GBRMessage));
		if(puppet.getMinDist()==Integer.MAX_VALUE) {
			for (BasicNode n : map.keySet()) {//dumb GBR
				puppet.setMinDist(Math.min(map.get(n),puppet.getMinDist()));
			}
			assert (puppet.getMinDist()!=Integer.MAX_VALUE)
				:"GBR routes aren't initialized in node "+puppet.ID+" at time "+Global.currentTime;
		}
		for (BasicNode n : map.keySet()) {//dumb GBR
			if(map.get(n) == puppet.getMinDist()) {
				m.hopto(puppet,n);
				puppet.send(m, n);
				return;
			}
		}

		assert (false);
	}

}
