package projects.GBR.nodes.nodeImplementations;

import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

import projects.GBR.behaviour.GBRBuilder;
import projects.GBR.behaviour.GBRTwoLevelProbaDupRouter;
import projects.GBR.messages.GBRMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.Behaviour;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.TypeSelector;

/**
 * GradientBasedRoutingNode : exactly what the title said. Will route messages
 * to the first found lower-gradient node. Starts at t=1000, so that the
 * gradient-building packets do their jobs.
 * 
 * Also tracks its messages, which are received, which have been seen, which are
 * lost. Hackish, but working.
 * 
 * @author rjamet
 * 
 */
public class GBRDupNode extends GBRNode {

	public static Map<Integer, Integer> count = new TreeMap<Integer, Integer>();

	public static Set<Integer> sreceived = new TreeSet<Integer>();
	public Set<Integer> received = new TreeSet<Integer>();

	@Override
	public void init() {
		super.init();

		Behaviour b; // The GBR behaviour we want to use
		if (bUseTwoLevels) {
			b = new GBRTwoLevelProbaDupRouter(distanceMap, min_dist, pSameLevel);
		} else {
			throw new RuntimeException("Not implemented yet");
		}

		rb = new RoutingBehaviour(this).add(new TypeSelector(GBRMessage.class),
				new GBRBuilder(distanceMap)).add(
				new AlwaysSelector(), b);
	}

}