package projects.GBR.nodes.nodeImplementations;

import java.util.Set;
import java.util.TreeSet;

import projects.GBR.behaviour.DedupReceptionBehaviour;
import projects.GBR.messages.GBRMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.BroadcastRouter;
import projects.common.behaviours.SilentDropBehaviour;
import projects.common.selector.AndSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.FirstHopSelector;
import projects.common.selector.TypeSelector;

public class GBRDupSink extends GBRSink {

	public Set<Integer> received = new TreeSet<Integer>();

	@Override
	public void init() {

		super.init();
		
		
		rb = new RoutingBehaviour(this).
				add(new AndSelector(
							new TypeSelector(GBRMessage.class), 
							new FirstHopSelector()
						),
						new BroadcastRouter()).
				add(new TypeSelector(GBRMessage.class), 
						new SilentDropBehaviour()).
				add(new DestinationSelector(-1), new DedupReceptionBehaviour());
	}

}
