package projects.GBR.nodes.nodeImplementations;

import projects.GBR.messages.GBRMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.BroadcastRouter;
import projects.common.behaviours.SilentDropBehaviour;
import projects.common.behaviours.SimpleReceptionBehaviour;
import projects.common.nodes.BasicNode;
import projects.common.selector.AndSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.FirstHopSelector;
import projects.common.selector.TypeSelector;
import projects.defaultProject.nodes.nodeImplementations.SinkNode;

public class GBRSink extends SinkNode {

	@Override
	public void init() {

		super.init();
		
		
		rb = new RoutingBehaviour(this).
				add(new AndSelector(
							new TypeSelector(GBRMessage.class), 
							new FirstHopSelector()
						),
						new BroadcastRouter()).
				add(new TypeSelector(GBRMessage.class), 
						new SilentDropBehaviour()).
				add(new DestinationSelector(-1), new SimpleReceptionBehaviour());
	}

	@Override
	protected void startTimers() {

		// initiate startup phase
		
		//Increase rolling messages as sendDirect bypasses the basicnode wrapper for send

		BasicNode.rolling_messages++;
		this.sendDirect((new GBRMessage(this, this, 1, 0, 0, null)),
					this);
		

		super.startTimers();
	}

}
