package projects.GBR.nodes.nodeImplementations;


import projects.GBR.messages.GBRMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.behaviours.BroadcastRouter;
import projects.common.behaviours.SilentDropBehaviour;
import projects.common.behaviours.SimpleReceptionBehaviour;
import projects.common.nodes.BasicNode;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.AndSelector;
import projects.common.selector.BeforeMidSimulationSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.FirstHopSelector;
import projects.common.selector.OrSelector;
import projects.common.selector.SecondHopSelector;
import projects.common.selector.TypeSelector;
import projects.defaultProject.nodes.nodeImplementations.SinkToBlackNode;

public class GBRSinkToBlackNode extends SinkToBlackNode {


	@Override
	public void init() {
		super.init();

		rb = new RoutingBehaviour(this)
				.add(new AndSelector(new AndSelector(
						new BeforeMidSimulationSelector(), new TypeSelector(
								GBRMessage.class)), 
								new OrSelector(
										new SecondHopSelector(),
										new FirstHopSelector()
										)),
						new BroadcastRouter())
				.add(new AndSelector(new BeforeMidSimulationSelector(),
						new TypeSelector(GBRMessage.class)),
						new SilentDropBehaviour())
				.add(new AndSelector(new BeforeMidSimulationSelector(),
						new DestinationSelector(-1)),
						new SimpleReceptionBehaviour())
				.add(new AlwaysSelector(), new BlackholeBehaviour());

	}

	@Override
	protected void startTimers() {

		// initiate startup phase
		BasicNode.rolling_messages++;
		
		//Increase rolling messages as sendDirect bypasses the basicnode wrapper for send

		this.sendDirect((new GBRMessage(this, this, 2, 0, 0, null)), this);

		super.startTimers();
	}
}
