package projects.GBR.nodes.nodeImplementations;

import projects.GBR.behaviour.DedupBlackholeBehaviour;
import projects.GBR.behaviour.GBRBuilder;
import projects.GBR.behaviour.GBRTwoLevelProbaDupRouter;
import projects.GBR.messages.GBRMessage;
import projects.RW.nodes.nodeImplementations.SFThenRWNode;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.Behaviour;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.ProbabilitySelector;
import projects.common.selector.TypeSelector;

/**
 * Extra-specific code, don't use it, don't touch anything
 * @author rjamet
 *
 */
public class SFThenGBRDupNode extends GBRDupNode {


	@Override
	public boolean sendsMessages() {
		return false;
	}

	@Override
	public void JSONOutput() {
		System.out.println("{\"t\":\"blackhole\", \"id\":" + ID + ", \"d\":"
				+ this.outgoingConnections.size() + "," + JSONNeighbors()
				+ "},");
	}

	@Override
	public void init() {
		super.init();

		Behaviour b; // The GBR behaviour we want to use
		if (bUseTwoLevels) {
			b = new GBRTwoLevelProbaDupRouter(distanceMap, min_dist, pSameLevel);
		} else {
			throw new RuntimeException("Not made for this");
		}

		rb = new RoutingBehaviour(this)
				.add(new TypeSelector(GBRMessage.class),
						new GBRBuilder(distanceMap))
				.add(new ProbabilitySelector(
						SFThenRWNode.interceptProbability),
						new DedupBlackholeBehaviour())
				.add(new AlwaysSelector(), b);
	}

}
