package projects.GBR.nodes.nodeImplementations;

import projects.GBR.behaviour.GBRBuilder;
import projects.GBR.behaviour.GBRLowerLevelFirstRouter;
import projects.GBR.behaviour.GBRLowerLevelProbaRouter;
import projects.GBR.behaviour.GBRTwoLevelProbaRouter;
import projects.GBR.messages.GBRMessage;
import projects.RW.nodes.nodeImplementations.SFThenRWNode;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.Behaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.ProbabilitySelector;
import projects.common.selector.TypeSelector;

public class SFThenGBRNode extends GBRNode {

	@Override
	public boolean sendsMessages() {
		return false;
	}

	@Override
	public void JSONOutput() {
		System.out.println("{\"t\":\"blackhole\", \"id\":" + ID + ", \"d\":"
				+ this.outgoingConnections.size() + "," + JSONNeighbors()
				+ "},");
	}

	@Override
	public void init() {
		super.init();
		

		Behaviour b; //The GBR behaviour we want to use
		if (bUseTwoLevels) {
			b = new GBRTwoLevelProbaRouter(distanceMap, pSameLevel);
		} else {
			if (bRandomize) {
				b = new GBRLowerLevelProbaRouter(distanceMap);
			} else {
				b = new GBRLowerLevelFirstRouter(distanceMap);
			}
		}
		
		rb = new RoutingBehaviour(this)
				.add(new TypeSelector(GBRMessage.class), 
					new GBRBuilder(distanceMap))
				.add(new ProbabilitySelector(SFThenRWNode.interceptProbability),
							new BlackholeBehaviour())
				.add(
					new AlwaysSelector(),
					b
				);	
		}
	
}
