package projects.Greedy.behaviour;

import java.util.Iterator;

import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import sinalgo.nodes.edges.Edge;

public class GreedyRouter implements Behaviour {

	BasicNode puppet;

	@Override
	public void init(BasicNode n) {
		this.puppet = n;
	}

	@Override
	public void act(BasicMessage m) {

		Iterator<Edge> it = puppet.getConnections().iterator();
		Edge closest;
		if (it.hasNext()) {
			closest = it.next();
		} else {
			return;
		}
		while (it.hasNext()) {
			Edge candidate = it.next();
			if (m.destination == null) {
				if (candidate.endNode.getPosition().distanceTo(
						BasicNode.sinkPos) < closest.endNode.getPosition()
						.distanceTo(BasicNode.sinkPos)) {
					closest = candidate;
				}
			} else {
				if (candidate.endNode.getPosition().distanceTo(
						m.destination.getPosition()) < closest.endNode.getPosition()
						.distanceTo(m.destination.getPosition())) {
					closest = candidate;
				}
			}
		}
		m.hopto(closest);
		puppet.send(m, closest.endNode);
	}

}
