package projects.RW.nodes.nodeImplementations;

import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.behaviours.RWRouter;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.ProbabilitySelector;
import projects.defaultProject.nodes.nodeImplementations.BlackholeNode;

public class SFThenRWNode extends BlackholeNode {

	static public double interceptProbability;

	@Override
	public void init() {
		super.init();
		assert (interceptProbability >= 0 && interceptProbability <= 1) : "Interception probability for SFNode is not in [0,1]";
		rb = new RoutingBehaviour(this)
				.add(new ProbabilitySelector(interceptProbability),
						new BlackholeBehaviour())
				.add(new AlwaysSelector(), new RWRouter());
	}

}
