package projects.SIGF.behaviour;

import java.util.Iterator;

import projects.SIGF.nodes.nodeImplementations.SIGFNode;
import projects.SIGF.nodes.nodeImplementations.SIGFNode.RouteTo;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import sinalgo.nodes.edges.Edge;

/**
 * a blackhole SIGF behavior that reforwards messages to the previous hop,
 * instead of broadcasting it. Does not even bother to route it properly.
 * 
 * @author rjamet
 * 
 */
public class SIGFSmartBHBehaviour extends SIGFBehaviour {

	public SIGFSmartBHBehaviour(RouteTo who) {
		super(who);
		// TODO Auto-generated constructor stub
	}

	@Override
	public void init(BasicNode puppet) {
		this.puppet = (SIGFNode) puppet;
	}

	@Override
	/** This node does not care about reputations */
	protected double reputation(Edge e) {
		return 1;
	}

	RouteTo policy;

	@Override
	public void act(BasicMessage m) {
		// pretend we forward, but we don't.

		if ((m.hops == 0 || m.destination != null // basic stuff
				&& m.destination.ID == puppet.ID)) {// for me

			Edge next = route(m);
			m.hopto(next);
			m.destination = (BasicNode)next.endNode; //NOT A NO-OP
			
			Iterator<Edge> it = puppet.getConnections().iterator();
			while (it.hasNext()) {
				Edge candidate = it.next();
				if ( ! m.destination.equals(candidate.endNode)) {
					puppet.send(m, candidate.endNode);
				}
			}
			
			puppet.eatMessage(m,
					BasicMessage.Status.INTERCEPTED);
			
		} else {
			
			puppet.eatMessage(m,
					BasicMessage.Status.DONOTLOG);
			
		}
		
		return;

	}

}
