package projects.SIGF.nodes.nodeImplementations;



import java.util.Iterator;

import projects.SIGF.behaviour.SIGFBehaviour;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.TTLedBehaviour;
import projects.common.nodes.BasicNode;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.TTLSelector;
import sinalgo.nodes.edges.Edge;
import sinalgo.nodes.messages.Message;


/**
 * SIGF node
 * 
 * @author rjamet
 * 
 */
public class SIGFNode extends BasicNode {

	
	
	Integer min_dist = Integer.MAX_VALUE;

	public static enum RouteTo {
		CONE60D, CLOSER, ALL
	}

	/**
	 * Basic broadcast bugs me, so it will just be a send to each neighbor
	*/
	@Override
	public void broadcast(Message m) {
		Iterator<Edge> it = getConnections().iterator();
		while(it.hasNext()) {
			Edge e = it.next();
			if (it.hasNext()) {
				Message clone = m.clone();
				this.send(clone, e.endNode);
			} else {
				this.send(m, e.endNode);
			}
		}
	} 	
	
	@Override
	public void init() {
		super.init();

		rb = new RoutingBehaviour(this)
			.add(new TTLSelector(),new TTLedBehaviour())
			.add(new AlwaysSelector(), new SIGFBehaviour(RouteTo.CLOSER));
	}

}