package projects.SIGF.nodes.nodeImplementations;



import java.util.Iterator;

import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.behaviours.SilentDropBehaviour;
import projects.common.behaviours.SimpleReceptionBehaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.AndSelector;
import projects.common.selector.BeforeMidSimulationSelector;
import projects.common.selector.DestinationSelector;
import projects.defaultProject.nodes.nodeImplementations.BlackholeNode;
import sinalgo.nodes.edges.Edge;
import sinalgo.nodes.messages.Message;


/**
 * SIGF node
 * 
 * @author rjamet
 * 
 */
public class SIGFWHNode extends BlackholeNode {

	public class FanfareReceptionBehaviour extends SimpleReceptionBehaviour {
		@Override
		public void act(BasicMessage m) {
			m.destination = BasicNode.nobody; m.hopto(puppet,puppet);
			Iterator<Edge> it = puppet.getConnections().iterator();
			while(it.hasNext()) {
				Edge e = it.next();
				if (it.hasNext()) {
					Message clone = m.clone();
					puppet.send(clone, e.endNode);
				} else {
					puppet.send(m, e.endNode);
				}
			}
			puppet.eatMessage(m, BasicMessage.Status.OK);
		}
	}
	
	@Override
	public void init() {
		super.init();

		rb = new RoutingBehaviour(this).
			add(
					new AndSelector(
							new DestinationSelector(this.ID), 
							new BeforeMidSimulationSelector()
					),
					new FanfareReceptionBehaviour()
			).
			add(new DestinationSelector(this.ID), new BlackholeBehaviour()).
			add(new AlwaysSelector(), new SilentDropBehaviour());
	}

	
	
}