package projects.TLCN.behaviour;

import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.nodes.BasicTabuNode;
import sinalgo.nodes.edges.Edge;

/**
 * Routes according to TLCN rules, <b>and updates counters/TLs</b>
 * 
 * @author rjamet
 * 
 */
public class TLCNRouter implements Behaviour {

	BasicTabuNode puppet;

	@Override
	public void init(BasicNode n) {
		if (n instanceof BasicTabuNode) {
			this.puppet = (BasicTabuNode) n;
		} else {
			throw new RuntimeException("TLCNRouter needs a BasicTabuNode");
		}
	}

	@Override
	public void act(BasicMessage m) {

		for (Edge e : puppet.getConnections()) {
			if (puppet.tl.get(e) == null) {
				puppet.initCheck(e);
			}

			if (puppet.tl.get(e).isin(m.idMessage))
				puppet.counters.put(e, puppet.counters.get(e)
						/ (puppet.counters.get(e) + 1));
		}

		Edge e = puppet.select(m);
		puppet.tl.get(e).add(m.idMessage);
		m.hopto(e);
		puppet.send(m, e.endNode);

	}

}
