package projects.TLCNS.behaviour.perNeighborTL;

import projects.TLCNS.messages.AckMessage;
import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.nodes.BasicTabuNode;
import sinalgo.nodes.edges.Edge;

/**
 * Behaviour of a sink or destination recepting a message
 * 
 * @author rjamet
 * 
 */
public class TLCNSAckReceptionBehaviour implements Behaviour {

	BasicTabuNode puppet;

	@Override
	public void init(BasicNode n) {
		if (n instanceof BasicTabuNode) {
			this.puppet = (BasicTabuNode) n;
		} else {
			throw new RuntimeException("CNBackRouter needs a BasicTabuNode");
		}
	}

	@Override
	public void act(BasicMessage m) {

		assert (m.destination.equals(puppet)) : "Message probably not intended for this node";
		assert (m instanceof AckMessage) : "Message isn't a ack";
		AckMessage ack = (AckMessage) m;

		
		for (Edge e : puppet.outgoingConnections) {
			puppet.initCheck(e);

			
			if (puppet.tl.get(e).isin(ack.AckID)) {
				puppet.counters.put(e, puppet.counters.get(e) + 1);
				puppet.tl.get(e).remove(ack.AckID);
				puppet.eatMessage(m, BasicMessage.Status.OK);
				return;
			}
		}

		puppet.eatMessage(m, BasicMessage.Status.FORGOT);
	}

}
