package projects.TLCNS.behaviour.perNeighborTL;


import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.nodes.BasicTabuNode;
import sinalgo.nodes.edges.Edge;

/**
 * Routes according to TLCN rules, <b>and updates counters/TLs</b>
 * 
 * @author rjamet
 * 
 */
public class TLCNSRouter implements Behaviour {

	BasicTabuNode puppet; 
	
	@Override
	public void init(BasicNode n) {
		if (n instanceof BasicTabuNode) {
			this.puppet = (BasicTabuNode) n;
		} else {
			throw new RuntimeException("TLCNSRouter needs a BasicTabuNode");
		}
	}

	@Override
	public void act(BasicMessage m) {

		for (Edge e : puppet.getConnections()) {
			puppet.initCheck(e);
		}

		Edge e = puppet.select(m);

		if (m.sender.equals(puppet)) {
			for (Edge e2 : puppet.getConnections()) {
				puppet.tl.get(e2).remove(m.idMessage);
			}
			puppet.tl.get(e).add(m.idMessage);
		}
		
		m.hopto(e);
		puppet.send(m, e.endNode);

	}

}
