package projects.TLCNS.behaviour.sharedTL;

import projects.TLCNS.messages.AckMessage;
import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.nodes.BasicTabuNode;
import projects.common.utils.TabuList;
import sinalgo.nodes.edges.Edge;
import sinalgo.tools.Tuple;

/**
 * Behaviour of a sink or destination recepting a message
 * 
 * @author rjamet
 * 
 */
public class TLCNSSharedAckReceptionBehaviour implements Behaviour {

	BasicTabuNode puppet;
	TabuList tl;

	public TLCNSSharedAckReceptionBehaviour(TabuList stl) {
		tl = stl;
	}

	@Override
	public void init(BasicNode n) {
		if (n instanceof BasicTabuNode) {
			this.puppet = (BasicTabuNode) n;
		} else {
			throw new RuntimeException("CNBackRouter needs a BasicTabuNode");
		}
	}

	@Override
	public void act(BasicMessage m) {

		assert (m.destination.equals(puppet)) : "Message probably not intended for this node";
		assert (m instanceof AckMessage) : "Message isn't a ack";
		AckMessage ack = (AckMessage) m;

		
		for (Edge e : puppet.outgoingConnections) {
			puppet.initCheck(e);
			Tuple<Edge, Integer> t = new Tuple<Edge, Integer>(e, ack.AckID);

			if (tl.isin(t)) {
				puppet.counters.put(e, puppet.counters.get(e) + 1);
				tl.remove(t);
				puppet.eatMessage(m, BasicMessage.Status.OK);
				return;
			}
		}

		puppet.eatMessage(m, BasicMessage.Status.FORGOT);
	}

}
