package projects.TLCNS.behaviour.sharedTL;

import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.nodes.BasicTabuNode;
import projects.common.utils.TabuList;
import sinalgo.nodes.edges.Edge;
import sinalgo.tools.Tuple;

/**
 * Routes according to TLCN rules, <b>and updates counters/TLs</b>
 * 
 * @author rjamet
 * 
 */
public class TLCNSSharedRouter implements Behaviour {

	BasicTabuNode puppet;
	TabuList tl;

	public TLCNSSharedRouter(TabuList tl) {
		this.tl = tl;
	}

	@Override
	public void init(BasicNode n) {
		if (n instanceof BasicTabuNode) {
			this.puppet = (BasicTabuNode) n;
		} else {
			throw new RuntimeException("CNBackRouter needs a BasicTabuNode");
		}
	}

	@Override
	public void act(BasicMessage m) {

		for (Edge e : puppet.getConnections()) {
			puppet.initCheck(e);
		}

		Edge e = puppet.select(m);

		if (m.sender.equals(puppet)) {
			for (Edge e2 : puppet.getConnections()) {
				Tuple<Edge, Integer> tuple = new Tuple<Edge, Integer>(e2,m.idMessage);
				tl.remove(tuple);
			}
			tl.add(new Tuple<Edge, Integer>(e,m.idMessage));

		}

		m.hopto(e);
		puppet.send(m, e.endNode);

	}

}
