package projects.TLCNS.behaviour.sharedTL;

import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.nodes.BasicTabuNode;
import projects.common.utils.TabuList;
import sinalgo.nodes.edges.Edge;
import sinalgo.tools.Tuple;

/**
 * Routes according to TLCNS rules, updates counters/TLs,
 * and stores routes for the acks in another TL
 * 
 * @author rjamet
 * 
 */
public class TLCNSSharedRouterAndAckStorer implements Behaviour {

	BasicTabuNode puppet;
	TabuList tl_sent;
	TabuList tl_return; 

	public TLCNSSharedRouterAndAckStorer(TabuList tl_sent, TabuList tl_return) {
		this.tl_sent = tl_sent;
		this.tl_return = tl_return;
	}

	@Override
	public void init(BasicNode n) {
		if (n instanceof BasicTabuNode) {
			this.puppet = (BasicTabuNode) n;
		} else {
			throw new RuntimeException("CNBackRouter needs a BasicTabuNode");
		}
	}

	@Override
	public void act(BasicMessage m) {

		for (Edge e : puppet.getConnections()) {
			puppet.initCheck(e);
		}

		Edge e = puppet.select(m);
		
		if (m.sender.equals(puppet)) {
			for (Edge e2 : puppet.getConnections()) {
				Tuple<Edge, Integer> tuple = new Tuple<Edge, Integer>(e2,m.idMessage);
				tl_sent.remove(tuple);		
				tl_return.remove(new Tuple<BasicNode,Integer>((BasicNode)e2.endNode,m.idMessage));
			}
			tl_sent.add(new Tuple<Edge, Integer>(e,m.idMessage));
		}

		tl_return.add(new Tuple<BasicNode,Integer>(m.lastNode,m.idMessage));


		m.hopto(e);
		puppet.send(m, e.endNode);

	}

}
