package projects.TLCNS.messages;

import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.utils.Tools;
import sinalgo.nodes.messages.Message;

public class AckMessage extends BasicMessage{
	
	public int AckID;
	
	public AckMessage(BasicNode sender, BasicNode lastNode, int hops, double timeBegin,
			int idMessage, BasicNode dest, int AckID) {
		super(sender,lastNode,hops,timeBegin,idMessage,dest);
		this.AckID=AckID;
	}
	
	@Override
	public Message clone() {
		return new AckMessage(sender, lastNode, hops, timeBegin, idMessage, destination, AckID);
	}

	@Override
	public String toJSON() {
		String st = "";

		st += ("{");
		st += ("\"id\":" + this.idMessage + ",");
		st += ("\"type\":\"ack\",");
		st += ("\"ackid\":"+this.AckID+",");
		st += ("\"h\":" + this.hops + ",");
		st += ("\"tb\":" + Tools.tojson(this.timeBegin) + ",");
		st += ("\"te\":" + Tools.tojson(this.timeEnd) + ",");
		st += ("\"f\":" + this.sender.ID + ",");
		st += ("\"d\":" + this.st + ",");
		st += ("\"o\":" + Tools.tojson(this.hops / (double)this.destination.distanceToSink) + ",");


		if (destination != null) {
			st += ("\"t\":" + this.destination.ID);
		} else {
			st += ("\"t\":-1");
		}

		st += ("}");
		return st;
	}


	
}
