package projects.TLCNS.nodes.nodeImplementations;

import projects.RW.nodes.nodeImplementations.SFThenRWNode;
import projects.TLCNS.behaviour.perNeighborTL.TLCNSAckRouterBehaviour;
import projects.TLCNS.behaviour.sharedTL.TLCNSSharedAckReceptionBehaviourRolling;
import projects.TLCNS.behaviour.sharedTL.TLCNSSharedRouterAndAckStorerRolling;
import projects.TLCNS.messages.AckMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.AckingReceptionBehaviour;
import projects.common.behaviours.Behaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.behaviours.RWRouter;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.AndSelector;
import projects.common.selector.BeforeMidSimulationSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.ProbabilitySelector;
import projects.common.selector.TypeSelector;
import projects.common.utils.TabuList;

public class AckingSinkToSFThenTLCNSNode extends TLCNSNode {

	
	@Override
	public boolean isSink() {
		return new BeforeMidSimulationSelector().activate(null);
	}
	
	@Override
	public void init() {
		super.init();


		assert (TLCNSNode.sharedtl && TLCNSNode.useAckTL);
		assert (SFThenRWNode.interceptProbability >= 0 && SFThenRWNode.interceptProbability <= 1) : "Interception probability for SFNode is not in [0,1]";

		TabuList atl = TabuList.build(ackTlType, ackTlSize);
		TabuList stl = TabuList.build();
		Behaviour bAck = new TLCNSAckRouterBehaviour(atl);
		Behaviour bAckReception = new TLCNSSharedAckReceptionBehaviourRolling(
				stl, tl_routing);
		Behaviour bMess = new TLCNSSharedRouterAndAckStorerRolling(stl, atl,
				tl_routing);
		
		rb = new RoutingBehaviour(this).
			add(
					new AndSelector(
							new TypeSelector(AckMessage.class), 
							new BeforeMidSimulationSelector()
					),new RWRouter()
			).add(
					new AndSelector(
							new DestinationSelector(-1), 
							new BeforeMidSimulationSelector()
					),new AckingReceptionBehaviour()
			).add(	new ProbabilitySelector(SFThenRWNode.interceptProbability),
					new BlackholeBehaviour()
			).add(	new AndSelector(
							new TypeSelector(AckMessage.class), 
							new DestinationSelector(this.ID)
					), bAckReception
			).add(new TypeSelector(AckMessage.class), bAck
			).add(new AlwaysSelector(), bMess);
	}

}
