package projects.TLCNS.nodes.nodeImplementations;

import java.util.Vector;

import projects.TLCNS.behaviour.perNeighborTL.TLCNSAckRouterBehaviour;
import projects.TLCNS.behaviour.sharedTL.TLCNSSharedAckReceptionBehaviour;
import projects.TLCNS.behaviour.sharedTL.TLCNSSharedRouterAndAckStorer;
import projects.TLCNS.messages.AckMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.Behaviour;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.AndSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.TypeSelector;
import projects.common.utils.TabuList;
import sinalgo.nodes.edges.Edge;
import sinalgo.nodes.messages.Message;
import sinalgo.runtime.Global;

/**
 * FIXME
 */
public class TLCNSNodeSteph extends TLCNSNode {

	public Vector<Double> rtl = new Vector<Double>();
	public int lastcount = 0;
	public double nextupdate = 200;

	@Override
	public void init() {
		super.init();

		Behaviour bAck, bMess, bAckReception;
		TabuList atl = TabuList.build(ackTlType, ackTlSize);
		TabuList stl = TabuList.build();
		bAck = new TLCNSAckRouterBehaviour(atl);
		bAckReception = new TLCNSSharedAckReceptionBehaviour(stl);
		bMess = new TLCNSSharedRouterAndAckStorer(stl, atl);

		rb = new RoutingBehaviour(this)
				.add(new AndSelector(new TypeSelector(AckMessage.class),
						new DestinationSelector(this.ID)), bAckReception)
				.add(new TypeSelector(AckMessage.class), bAck)
				.add(new AlwaysSelector(), bMess);
	}

	@Override
	protected void action(Message msg_receive) {
		super.action(msg_receive);
		if (msg_receive instanceof AckMessage
				&& ((AckMessage) msg_receive).destination == this) {
			rtl.add(Global.currentTime);
		}
		if (nextupdate < Global.currentTime) {
			nextupdate += 200;
			if (rtl.size() < 0.8 * lastcount) {
				Edge max = this.getConnections().iterator().next();
				for (Edge n : this.getConnections()) {
					if (counters.get(n) > counters.get(max)) {
						max = n;
					}
				}
				counters.put(max, 1.0);
			}
			lastcount = rtl.size();
			rtl.clear();
		}
	}

}
