package projects.TLM.behaviour;

import java.util.Vector;

import projects.TLM.messages.TLMMessage;
import projects.common.behaviours.Behaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.nodes.BasicTabuNode;
import projects.common.utils.TabuList;
import sinalgo.nodes.edges.Edge;

/**
 * Routes according to TLCN rules, <b>and updates counters/TLs</b>
 * @author rjamet
 *
 */
public class TLMRouter implements Behaviour {

	BasicNode puppet;
	TabuList tl;

	@Override
	public void init(BasicNode n)  {
		tl = TabuList.build();
		if (n instanceof BasicTabuNode) {
			this.puppet = (BasicTabuNode) n;
		} else {
			throw new RuntimeException("TLMRouter needs a BasicTabuNode");
		}
	}
	

	@Override
	public void act(BasicMessage m) {
		assert (m instanceof TLMMessage);
		TLMMessage tlm = (TLMMessage) m;
		
		Vector<Edge> p = new Vector<Edge>();
		for (Edge e : puppet.getConnections()) {
			if (tlm.tl.count(e.endNode) == 0) {
				p.add(e);
			}
		}

		Edge dest;
		if (p.isEmpty()) { //All nodes are blacklisted
			dest = puppet.chooseRandomFromCollection(puppet.getConnections());
		} else { //Choose from the non-blacklisted nodes
			dest = p.get((int)sinalgo.tools.statistics.UniformDistribution.nextUniform(0, p.size()));
		}
		tlm.tl.add(puppet);
		m.hopto(dest);
		puppet.send(m, dest.endNode);

	}

}
