package projects.common.behaviours;

import projects.TLCNS.messages.AckMessage;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import sinalgo.runtime.Global;


/**
 * Behaviour of a sink or destination recepting a message
 * @author rjamet
 *
 */
public class AckingReceptionBehaviour implements Behaviour {

	BasicNode puppet;

	@Override
	public void init(BasicNode puppet) {
		this.puppet = puppet;
	}

	@Override
	public void act(BasicMessage m) {
		
//		assert ((m.destination == null && puppet.isSink()) || m.destination.equals(puppet)) : 
//			"Message probably not intended for this node";
		
		puppet.eatMessage(m, BasicMessage.Status.OK);
		
		puppet.send(new AckMessage(puppet, puppet, 1, Global.currentTime,
				projects.common.utils.Tools.generateID(), m.sender,
				m.idMessage), m.lastNode);
		
	}

}
