package projects.common.behaviours;

import java.util.Iterator;

import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import sinalgo.nodes.edges.Edge;
import sinalgo.nodes.messages.Message;

public class BroadcastRouter implements Behaviour {

	BasicNode puppet;

	@Override
	public void init(BasicNode n) {
		this.puppet = n;
	}

	
	@Override
	public void act(BasicMessage m) {
		Iterator<Edge> it = puppet.getConnections().iterator();
		while(it.hasNext()) {
			Edge e = it.next();
			if (it.hasNext()) {
				Message clone = m.clone();
				puppet.send(clone, e.endNode);
			} else {
				puppet.send(m, e.endNode);
			}
		}
	}

}
