package projects.common.behaviours;

import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;


/**
 * Behaviour of a sink or destination recepting a message
 * @author rjamet
 *
 */
public class SimpleReceptionBehaviour implements Behaviour {

	protected BasicNode puppet;

	@Override
	public void init(BasicNode puppet) {
		this.puppet = puppet;
	}

	@Override
	public void act(BasicMessage m) {
		
		assert ((m.destination == null && puppet.isSink()) || m.destination.equals(puppet)) : 
			"Message probably not intended for this node";
		
		puppet.eatMessage(m, BasicMessage.Status.OK);
		// chomp chomp
	}

}
