package projects.common.selector;

import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;

/**
 * True for msgs with destination==-1
 * @author rjamet
 *
 */
public class DestinationSelector implements Selector {

	int destID;
	
	public DestinationSelector(int ID) {
		destID = ID;
	}
	
	@Override
	public boolean activate(BasicMessage m) {
		if (m.destination == null) {
			return destID == -1;
		} else if (m.destination.equals(BasicNode.nobody)) {
			return false;
		} else {
			return (m.destination.ID == destID);
		}
	}

	@Override
	public void init() {
		//void
	}
	
}
