package projects.common.selector;

import projects.common.messages.BasicMessage;

public class ProbabilitySelector implements Selector {

	double p;
	
	public ProbabilitySelector(double p) {
		assert(p >= 0 && p <= 1):"ProbabilitySelector has a p not in [0,1]";
		this.p = p;
	}
	
	@Override
	public boolean activate(BasicMessage m) {
		return sinalgo.tools.statistics.UniformDistribution.nextUniform(0, 1) < p;
	}

	@Override
	public void init() {
		//nothing
	}

}
