package projects.common.timers;

import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.timers.SenderTimer;
import sinalgo.configuration.Configuration;
import sinalgo.nodes.timers.Timer;
import sinalgo.runtime.Global;


/**
 * Timer used to kill the simulation when all messages are sent
 * TODO : put that where it belongs
 * 
 * 
 * @author rjamet
 */
public class EnderTimer extends Timer {

	double check_interval = 25;
	boolean lastwait = false;
	boolean firstrun = true;
	
	public EnderTimer() {}

	@Override
	public void fire() {
		if (firstrun) {
			firstrun = false;
			firstrun();
		}
		
		if (!lastwait) {
			if (BasicNode.rolling_messages == 0 && SenderTimer.hasSentAllRequired()) {
				lastwait = true;
				this.startGlobalTimer(5000);
			} else {
				this.startGlobalTimer(check_interval);
			}
		} else {
			lastrun();
			sinalgo.runtime.Main.exitApplication();	
		}
	}
	
	public void firstrun() {
		System.out.println("===BEGIN MESSAGE DATA===");
	}
	
	public void lastrun() {
		System.out.println("===END MESSAGE DATA===");
		System.out.println("{ \"nodes\" : [");
		for(BasicNode n : BasicNode.list) {
			if (n != null) n.JSONOutput();
		}
		System.out.println("]");
		System.out.println(","); //close that run		System.out.println("{ "); //BEGIN SIMULATION
		System.out.println("\"simulation\" : {");
		
		//should print all the relevant simulation info
		System.out.println("\t\"project\":\""+Global.projectName+"\",");
		System.out.println("\t\"seed\":\""+Configuration.fixedSeed+"\",");
		System.out.println("\t\"total_nbhops\":\""+BasicMessage.Total_nbhops+"\"");
		System.out.println("}}");
		
	}
}

