package projects.common.utils;

public class Bloom {

	private int size;
	private int hsize;

	
	private byte array[];
	private IntKeyedHashFunc h[];
	private IntKeyedHashFunc h_hack;

	
	/**
	 * FIXME One big mess of a class you shouldn't use right now
	 * 
	 * @param size
	 * @param hsize
	 */
	public Bloom (int size, int hsize) {

		this.size = size/8;
		this.hsize = hsize;
		array 	= new byte[size];
		h 	= new IntKeyedHashFunc[hsize];
		h_hack = new IntKeyedHashFunc(
				(int)sinalgo.tools.statistics.UniformDistribution.nextUniform(0, Integer.MAX_VALUE+1), 0);
		for (int i=0;i<hsize;i++) {
			h[i] = new IntKeyedHashFunc(i,size);
		}
	}

	public void add(int val) {
		val = h_hack.fullhash(val);
		for (int i=0;i<hsize;i++) {
			int hval = h[i].hash(val);
			array[(hval) / 8] |= 1 << (hval % 8);
		}
	}


	public boolean isin(int val) {
		val = h_hack.fullhash(val);
		boolean found = true;
		for (int i=0;i<hsize;i++) {
			int hval = h[i].hash(val);
			found = found && ((array[(hval) / 8]) & (1 << (hval % 8)))!=0;
		}
		return found;
	}

	public void display() {
		for (int i=0;i<size;i++) {
			for (int j=0;j<8;j++) {
				if ((array[i] & (1 << j))!=0) {
					System.out.print("1");
				} else {
					System.out.print("O");
				}
			}
			System.out.print("\n");
		}
	}

	public float fill() {
		int ones = 0;
		for (int i=0;i<size;i++) {
			for (int j=0;j<8;j++) {
				if ((array[i] & (1 << j))!=0) {
					ones++;
				}
			}
		}
		return ones;
	}
	
	public float fillquota() {
		return (fill() / (size*8));
	}

	public double falsePositiveChance() {
		return (Math.pow(fillquota(),hsize));
	}

}
