/*
 Copyright (c) 2007, Distributed Computing Group (DCG)
                    ETH Zurich
                    Switzerland
                    dcg.ethz.ch

 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 - Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

 - Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the
   distribution.

 - Neither the name 'Sinalgo' nor the names of its contributors may be
   used to endorse or promote products derived from this software
   without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
package projects.defaultProject.models.connectivityModels;

import sinalgo.configuration.CorruptConfigurationEntryException;
import sinalgo.nodes.Node;
import sinalgo.nodes.Position;
import sinalgo.tools.Tuple;
import java.util.ArrayList;

/**
 * A UDG connectivity model for static network. The connections are only evaluated
 * the very first time according to the UDG connectivity model, and then reused all 
 * over again.
 * @see projects.defaultProject.models.connectivityModels.UDG
 */
public class PlanarStaticUDG extends StaticUDG {
	
	@SuppressWarnings("unused")
	private static ArrayList<Tuple<Position, Position>> links= new ArrayList<Tuple<Position,Position>>();
	
	public PlanarStaticUDG() throws CorruptConfigurationEntryException {
		super();
	}


	
	@Override
	protected boolean isConnected(Node from, Node to){
		/*
		Position p1 = from.getPosition();
		Position p2 = to.getPosition();
		
		double distance = p1.squareDistanceTo(p2);
		if (distance < squareRadius) {
						
			for(Tuple<Position,Position> tp : links) {
				if (isIntersecting(tp, new Tuple<Position, Position>(p1,p2))) {
					System.out.println("pouet");		
					return false;
				}
			}
			links.add(new Tuple<Position, Position>(p1,p2));
			return true;
			
		} else {	

		}*/
		return false;
	}
	
}

