package projects.defaultProject.nodes.nodeImplementations;

import projects.TLCNS.messages.AckMessage;
import projects.TLCNS.nodes.nodeImplementations.TLCNSNode;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.AckingReceptionBehaviour;
import projects.common.behaviours.RWRouter;
import projects.common.behaviours.TeleportToDestinationRouter;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.TypeSelector;

public class AckingSinkNode extends SinkNode {

	@Override
	public void init() {
		super.init();
		rb = new RoutingBehaviour(this)
				.add(new TypeSelector(AckMessage.class),
						TLCNSNode.teleportAcks ? new TeleportToDestinationRouter()
								: new RWRouter())
				.add(new DestinationSelector(-1),
						new AckingReceptionBehaviour())
				.add(new AlwaysSelector(), new RWRouter());

	}

}
