package projects.defaultProject.nodes.nodeImplementations;

import projects.TLCNS.messages.AckMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.AckingReceptionBehaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.behaviours.RWRouter;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.AndSelector;
import projects.common.selector.BeforeMidSimulationSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.TypeSelector;

public class AckingSinkToBlackNode extends SinkToBlackNode {

	
	
	@Override
	public void init() {
		super.init();

		rb = new RoutingBehaviour(this).
			add(
					new AndSelector(
							new TypeSelector(AckMessage.class), 
							new BeforeMidSimulationSelector()
							),new RWRouter()
			).
			add(
					new AndSelector(
							new DestinationSelector(-1), 
							new BeforeMidSimulationSelector()
							),new AckingReceptionBehaviour()
			).
			add(new AlwaysSelector(), new BlackholeBehaviour());
	}

}
