package projects.defaultProject.nodes.nodeImplementations;

import projects.TLCNS.messages.AckMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.AckingReceptionBehaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.behaviours.RWRouter;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.AndSelector;
import projects.common.selector.BackAndForthSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.Selector;
import projects.common.selector.TypeSelector;

public class AckingSinkToFromBlackNode extends SinkToBlackNode {

	//TODO
	
	public static int packetAmount;
	Selector s;

	@Override
	public boolean isSink() {
		if(s == null) {
			return true;
		}
		return s.activate(null);
	}
	
	@Override
	public void init() {
		super.init();

		s = new BackAndForthSelector(packetAmount);

		rb = new RoutingBehaviour(this).
			
			add(
					new AndSelector(
							new TypeSelector(AckMessage.class), 
							s
							),new RWRouter()
			).
			add(
					new AndSelector(
							new DestinationSelector(-1), 
							s
							),new AckingReceptionBehaviour()
			).
			add(new AlwaysSelector(), new BlackholeBehaviour());
	}

}
