package projects.defaultProject.nodes.nodeImplementations;

import java.awt.Color;


import projects.GBR.messages.GBRMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.Behaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.messages.BasicMessage;
import projects.common.nodes.BasicNode;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.TypeSelector;
import sinalgo.nodes.edges.Edge;

public class BlackholeNode extends BasicNode {
	
	private class BlackholeGBRBuilder implements Behaviour {

			BlackholeNode puppet;
			int md = Integer.MAX_VALUE;

			@Override
			public void init(BasicNode puppet) {
				assert(puppet instanceof BlackholeNode );
				this.puppet = (BlackholeNode) puppet;
			}
			
			@Override
			public void act(BasicMessage m) {
				 assert (m instanceof GBRMessage) :
				 "This should only route GBR building messages";
				GBRMessage bm = (GBRMessage) m;


				if (bm.hops < md) {
					md = bm.hops;

					for (Edge e : puppet.getConnections()) {
						GBRMessage mc = (GBRMessage) bm.clone();
						mc.hopto(e);
						puppet.send(mc, e.endNode);
					}
				}
			}

		}
	
	@Override
	public boolean sendsMessages() {
		return false;
	}
	
	@Override
	public void init() {
		super.init();
		rb = new RoutingBehaviour(this).
			add(new TypeSelector(GBRMessage.class), new BlackholeGBRBuilder()).
			add(new AlwaysSelector(), new BlackholeBehaviour());
	}
	
	@Override
	public Color getColor() {
		return Color.RED;
	}

	@Override
	/**
	 * TODO clean, and override properly from BasicNode
	 */
	public void JSONOutput() {
		System.out.println("{\"t\":\""+JSONName()+"\", \"id\":"+ID+", \"d\":"+this.outgoingConnections.size()+","+ JSONNeighbors() +"},");		
	}

	@Override
	/**
	 * Unused, should be called by JSONOutput
	 */
	public String JSONName() {
		return "blackhole";
	}
}
