package projects.defaultProject.nodes.nodeImplementations;

import projects.GBR.messages.GBRMessage;
import projects.TLCNS.messages.AckMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.RWRouter;
import projects.common.behaviours.SilentDropBehaviour;
import projects.common.behaviours.SimpleReceptionBehaviour;
import projects.common.nodes.BasicNode;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.TypeSelector;

public class SinkNode extends BasicNode {

	
	
	@Override
	public boolean isSink() {
		return true;
	}
	
	@Override
	public boolean sendsMessages() {return false;}
	
	@Override
	public void init() {
		BasicNode.sink = this;
		this.distanceToSink = 0;

		rb = new RoutingBehaviour(this).
			add(new TypeSelector(AckMessage.class), new RWRouter()).
			add(new TypeSelector(GBRMessage.class), new SilentDropBehaviour()).
			add(new DestinationSelector(-1), new SimpleReceptionBehaviour()).
			add(new DestinationSelector(this.ID), new SimpleReceptionBehaviour()).
			add(new AlwaysSelector(), new RWRouter());
		super.init();
	}

	@Override
	public String JSONName() {return "sink";}

}
