package projects.defaultProject.nodes.nodeImplementations;

import java.awt.Color;

import projects.TLCNS.messages.AckMessage;
import projects.common.RoutingBehaviours.RoutingBehaviour;
import projects.common.behaviours.BlackholeBehaviour;
import projects.common.behaviours.RWRouter;
import projects.common.behaviours.SimpleReceptionBehaviour;
import projects.common.selector.AlwaysSelector;
import projects.common.selector.AndSelector;
import projects.common.selector.BeforeMidSimulationSelector;
import projects.common.selector.DestinationSelector;
import projects.common.selector.TypeSelector;

public class SinkToBlackNode extends SinkNode {
	
	@Override
	public boolean isSink() {
		return new BeforeMidSimulationSelector().activate(null);
	}
	
	
	@Override
	public Color getColor() {
		if(this.isSink()) {
			return Color.BLUE;
		} else { //blackhole
			return Color.RED;
		}
	}


	@Override
	public void init() {
		super.init();

		rb = new RoutingBehaviour(this).
			add(
					new AndSelector(
							new TypeSelector(AckMessage.class), 
							new BeforeMidSimulationSelector()
							),new RWRouter()
			).
			add(
					new AndSelector(
							new DestinationSelector(-1), 
							new BeforeMidSimulationSelector()
							),new SimpleReceptionBehaviour()
					).
			add(new AlwaysSelector(), new BlackholeBehaviour());
	}

	@Override
	public String JSONName() {return "sinktoBH";}

}
