#!/usr/bin/perl
# Ad-hoc caller to group.pl for the final results of 
# our TLCNS simulations

my $origindir = "~/Work/Code/sinalgo/results_temp";
my $resdir = "../grouped_results";
my @ALGOS = ("GFG", "GBR", "RGBR", "PRGBR", "PRDGBR", "RW", "SR3");

for $nbn (200) {
	for $deg (8,12,16,20,24,28,32) {
		for $nba ("30") {
			`rm -f *.data *.svg res/${nbn}$-{deg}-${nba}`;
			for $alg (sort ("SR3", "RW", "GFG", "GBR", "RGBR", "PRGBR", "PRDGBR")) {
				print `perl group.pl ${nbn}-${deg}-${nba}-${alg} $origindir/${alg}_${nbn}_${deg}_${nba}*`;
			}
			`mkdir -p $resdir/${nbn}-${deg}-${nba}`;
			`mv *.data  $resdir/${nbn}-${deg}-${nba}`;
		}
	}
}

