#!/usr/bin/perl

use Term::ANSIColor;
use JSON;
use strict;
use warnings;

sub getvalfromto {
	my $data = shift;
	my $f = shift;
	my $t = shift;
	if (exists $data->[$f]->{counters}->{$t}) {
		return $data->[$f]->{counters}->{$t};
	}
	return 0;
}

my $twoarg = 1;

open (my $bf, shift) or die;
open (my $ff, shift) or ($twoarg = 0);

my @bf = <$bf>;

my $d_b = JSON->new->decode(join " ",@bf);
	my @ff; 
	my $d_f;

if ($twoarg){
@ff = <$ff>;
$d_f  = JSON->new->decode(join " ",@ff);
}

for my $n (1..(@{$d_b}-1)) {
	print (($d_b->[$n]->{id}).": ");
	my $sum1 = 0; 
	$sum1 += $d_b->[$n]->{counters}->{$_} for (keys %{$d_b->[$n]->{counters}});

		my $sum2 = 0; 
	if ($twoarg) {
		$sum2 += $d_f->[$n]->{counters}->{$_} for (keys %{$d_f->[$n]->{counters}});
	}

	for my $d (sort { getvalfromto($d_b,$n,$b) <=> getvalfromto($d_b,$n,$a) } (1..@{$d_b})) {
		my $p1 = getvalfromto($d_b,$n,$d) / $sum1;
		
		if ($twoarg) {
			my $p2 = getvalfromto($d_f,$n,$d) / $sum2;

			if (($p1)-($p2) > 0.01) {
				print color 'red';
			} elsif (($p1)-($p2) < -0.01) {
				print color 'blue';
			}
		}
		
		printf($d.":\%.2f ", $p1) if $p1 != 0;
	
		if ($twoarg) {
			print color 'reset';
		}

	}	
	print "\n";
}

