use Runner::Stats;
use List::Util qw/reduce sum max min/;
use JSON::XS;

# Quick


sub work {
	my $dir = $_;

	$dir =~ s/\/$//;	

	open (my $NODEFILE, "$dir/node_data.json");
	my $json_node_data = join "",<$NODEFILE>;
	close $NODEFILE;
	my $node_data = JSON::XS->new->relaxed->decode($json_node_data);

	open (my $SIMFILE, "$dir/glob.json");
	my $json_sim_data = join "",<$SIMFILE>;
	close $SIMFILE;
	my $sim_data = JSON::XS->new->relaxed->decode($json_sim_data);



  my @cleandata =
    sort {$a <=> $b}
    map {$_->{dr}}
    grep {$_->{t} ne "blackhole" && $_->{t} ne "sink"} @{$node_data};
  $sim_data->{boxplot}->[0] = $cleandata[int (@cleandata*0.1)];
  $sim_data->{boxplot}->[1] = $cleandata[int (@cleandata*0.25)];
  $sim_data->{boxplot}->[2] = $cleandata[int (@cleandata*0.5)];
  $sim_data->{boxplot}->[3] = $cleandata[int (@cleandata*0.75)];
  $sim_data->{boxplot}->[4] = $cleandata[int (@cleandata*0.9)];

  #Stacks ORANGE-like
  @cleandata = grep {$_->{t} !~ /blackhole/ && $_->{t} !~ /sink/} @{$node_data};
  $sim_data->{classes}->[0] = grep {$_->{dr} <= 0} @cleandata;
  $sim_data->{classes}->[1] = grep {$_->{dr} > 0.0    && $_->{dr} <=  0.33} @cleandata;
  $sim_data->{classes}->[2] = grep {$_->{dr} > 0.33 && $_->{dr} <=  0.66} @cleandata;
  $sim_data->{classes}->[3] = grep {$_->{dr} > 0.66 && $_->{dr} < 1} @cleandata;
  $sim_data->{classes}->[4] = grep {$_->{dr} >= 1} @cleandata;

	my $name = $dir;
	if ($dir =~ /\/([\d\w_\-\.]+)\/?$/) {
		$name = $1;
	}

  open (my $glob, "> $dir/classes.data");
    print $glob $name." ".join (" ",  map { $_ / (sum @{$sim_data->{classes}}) } @{$sim_data->{classes}});
  close $glob;

  open ($glob, "> $dir/moustache.data");
    print $glob $name." ".join (" ",@{$sim_data->{boxplot}});
  close $glob;


  `cp ../runnerv3/plotfiles/* $dir`;
  foreach (`ls ../runnerv3/plotfiles`) {
    print "cd $dir && chmod +x $_ && ./$_ " ;
    print $_;
    chomp;
    `cd $dir && chmod +x $_ && ./$_ ` if /\.pl$|\.plot$/;
  }
  `rm $dir/*.pl $dir/*.plot `;


  return 0;


}

while($a = shift) {
	push @datadirs, $a;
}


for (@datadirs) {
	work $_;
}
