#!/usr/bin/gnuplot

set term svg 
set view 60,30
set zrange [0:1]
set yrange [50:400]
set ytics 100,100
set xrange [8:32]
set xtics 8,8

set grid

#ALGO-SPECIFIC

set out "plots/TLCNS.svg"
splot "./TLCNS/0/data.txt" u 1:2:3 with lines t "0pct",\
	"./TLCNS/10/data.txt" u 1:2:3 with lines t "10pct",\
	"./TLCNS/20/data.txt" u 1:2:3 with lines t "20pct",\
	"./TLCNS/30/data.txt" u 1:2:3 with lines t "30pct";

set out "plots/RW.svg"
splot "./RW/0/data.txt" u 1:2:3 with lines t "0pct",\
	"./RW/10/data.txt" u 1:2:3 with lines t "10pct",\
	"./RW/20/data.txt" u 1:2:3 with lines t "20pct",\
	"./RW/30/data.txt" u 1:2:3 with lines t "30pct";

set out "plots/PRDGBR.svg"
splot "./PRDGBR/0/data.txt" u 1:2:3 with lines t "0pct",\
	"./PRDGBR/10/data.txt" u 1:2:3 with lines t "10pct",\
	"./PRDGBR/20/data.txt" u 1:2:3 with lines t "20pct",\
	"./PRDGBR/30/data.txt" u 1:2:3 with lines t "30pct";

set out "plots/PRGBR.svg"
splot "./PRGBR/0/data.txt" u 1:2:3 with lines t "0pct",\
	"./PRGBR/10/data.txt" u 1:2:3 with lines t "10pct",\
	"./PRGBR/20/data.txt" u 1:2:3 with lines t "20pct",\
	"./PRGBR/30/data.txt" u 1:2:3 with lines t "30pct";

set out "plots/PGBR.svg"
splot "./PGBR/0/data.txt" u 1:2:3 with lines t "0pct",\
	"./PGBR/10/data.txt" u 1:2:3 with lines t "10pct",\
	"./PGBR/20/data.txt" u 1:2:3 with lines t "20pct",\
	"./PGBR/30/data.txt" u 1:2:3 with lines t "30pct";

set out "plots/GBR.svg"
splot "./GBR/0/data.txt" u 1:2:3 with lines t "0pct",\
	"./GBR/10/data.txt" u 1:2:3 with lines t "10pct",\
	"./GBR/20/data.txt" u 1:2:3 with lines t "20pct",\
	"./GBR/30/data.txt" u 1:2:3 with lines t "30pct";

set out "plots/GFG.svg"
splot "./GFG/0/data.txt" u 1:2:3 with lines t "0pct",\
	"./GFG/10/data.txt" u 1:2:3 with lines t "10pct",\
	"./GFG/20/data.txt" u 1:2:3 with lines t "20pct",\
	"./GFG/30/data.txt" u 1:2:3 with lines t "30pct";

#ATTACKERQUANTITY-SPECIFIC

set out "plots/0pct.svg"
splot "./GFG/0/data.txt" u 1:2:3 with lines t "GFG",\
	"./PRDGBR/0/data.txt" u 1:2:3 with lines t "PRDGBR",\
	"./PRGBR/0/data.txt" u 1:2:3 with lines t "PRGBR",\
	"./PGBR/0/data.txt" u 1:2:3 with lines t "PGBR",\
	"./GBR/0/data.txt" u 1:2:3 with lines t "GBR",\
	"./RW/0/data.txt" u 1:2:3 with lines t "RW",\
	"./TLCNS/0/data.txt" u 1:2:3 with lines t "TLCNS";

set zrange [1:1000]
set logscale z

set out "plots/routelength.svg"
splot "./GFG/0/data.txt" u 1:2:4 with lines t "GFG",\
	"./PRDGBR/0/data.txt" u 1:2:4 with lines t "PRDGBR",\
	"./PRGBR/0/data.txt" u 1:2:4 with lines t "PRGBR",\
	"./PGBR/0/data.txt" u 1:2:4 with lines t "PGBR",\
	"./GBR/0/data.txt" u 1:2:4 with lines t "GBR",\
	"./RW/0/data.txt" u 1:2:4 with lines t "RW",\
	"./TLCNS/0/data.txt" u 1:2:4 with lines t "TLCNS";


set zrange [0:1]
unset logscale z

set out "plots/10pct.svg"
splot "./GFG/10/data.txt" u 1:2:3 with lines t "GFG",\
	"./PRDGBR/10/data.txt" u 1:2:3 with lines t "PRDGBR",\
	"./PRGBR/10/data.txt" u 1:2:3 with lines t "PRGBR",\
	"./PGBR/10/data.txt" u 1:2:3 with lines t "PGBR",\
	"./GBR/10/data.txt" u 1:2:3 with lines t "GBR",\
	"./RW/10/data.txt" u 1:2:3 with lines t "RW",\
	"./TLCNS/10/data.txt" u 1:2:3 with lines t "TLCNS";

set out "plots/20pct.svg"
splot "./GFG/20/data.txt" u 1:2:3 with lines t "GFG",\
	"./PRDGBR/20/data.txt" u 1:2:3 with lines t "PRDGBR",\
	"./PRGBR/20/data.txt" u 1:2:3 with lines t "PRGBR",\
	"./PGBR/20/data.txt" u 1:2:3 with lines t "PGBR",\
	"./GBR/20/data.txt" u 1:2:3 with lines t "GBR",\
	"./RW/20/data.txt" u 1:2:3 with lines t "RW",\
	"./TLCNS/20/data.txt" u 1:2:3 with lines t "TLCNS";

set out "plots/30pct.svg"
splot "./GFG/30/data.txt" u 1:2:3 with lines t "GFG",\
	"./PRDGBR/30/data.txt" u 1:2:3 with lines t "PRDGBR",\
	"./PRGBR/30/data.txt" u 1:2:3 with lines t "PRGBR",\
	"./PGBR/30/data.txt" u 1:2:3 with lines t "PGBR",\
	"./GBR/30/data.txt" u 1:2:3 with lines t "GBR",\
	"./RW/30/data.txt" u 1:2:3 with lines t "RW",\
	"./TLCNS/30/data.txt" u 1:2:3 with lines t "TLCNS";
