#!/usr/bin/perl
# rjamet may 2014
# A script to take all the HOLE* results, and 
# print out the useful infos

use strict;
use warnings;
use List::Util qw/sum/;
use Cwd; #for getcwd
my $RES_DIR=getcwd."/../../results/";
my $GRAPH_DIR=getcwd."/../../runnerv3/graphs/";

#Hardcoded for now
my $GRAPH_H1_DIR = $GRAPH_DIR . "holeyudg1_200_20_125/";
my $GRAPH_H2_DIR = $GRAPH_DIR . "holeyudg1_200_20_125/";

for ("HOLE1-HOLE","HOLE2-HOLE","HOLE1-BH","HOLE2-BH") {
	print "[+] ==== For $_ ====\n";
	my @dirs = `ls $RES_DIR/. | grep $_`;
	print "[+] Found ".@dirs." simulations\n";

	print "[+] Simulation information :\n";
	print "dlvd ttld attk:\n";

	my $sumttl = 0; my $sumdr = 0; my $sumint = 0;
	for (@dirs) {
		chomp;
		my $dir = $RES_DIR.$_;
		my $dr = `cat $dir/glob.json | grep "dr\\"" | grep -oP "\\d\\.?\\d*"`;
		my $ttl = `cat $dir/glob.json | grep "ttl\\"" | grep -oP "\\d\\.?\\d*"`;
		chomp($dr,$ttl);
		my $int = 1 - $dr - $ttl;
		if ($int < 0.0000001 ) { $int = 0;}
		$sumttl += $ttl; $sumdr += $dr; $sumint += $int;
#		print "$dr $ttl $int \n";
	}
	printf("%3.3f %3.3f %3.3f\n", $sumdr/@dirs, $sumttl/@dirs, $sumint/@dirs);

	print "[+] Graph informations :\n";

	my @jam; my @ndeco;
	for (@dirs) {
		chomp;
		my $dir = $RES_DIR.$_;
		my $j = (190 - (`cat $dir/node_data.json | grep "tabu" | wc -l`))/1.90;

		push @jam, $j; 
		push @ndeco, (`cat $dir/node_data.json | grep -P "dr\\"\\s*:\\s*(0\..+|1)" | wc -l`) / ( 190 - ($j*1.90) ) * 100;
	}

	printf("co: \%3.3f pct, jam: \%3.3f pct\n", (sum @ndeco) / @ndeco, (sum @jam)/@jam);

}