#!/usr/bin/perl
use List::Util qw/max/;
use JSON::XS;
srand;

my @intervals = (1600,12800,102400);
my @datadirs = map {"../../../results/WHSWITCH-".$_."-SR3_200_8_5pct_s0_5"} @intervals;

for (0..@datadirs) {
	my $cmd = "perl ../shrink.pl < ".$datadirs[$_]."/de_tb.data 5 > $intervals[$_].data";
	print $cmd;
	`$cmd`;
}

my $plot = <<END; 
#!/usr/bin/gnuplot
set output "./delivery.eps"
#set title "DR of different algorithms on a 200 nodes, degree 8 network against 5 pct BH and 5 pct WH"
set term postscript eps monochrome enhanced size 7,3 18;
set key right bottom
set xrange [0:]
set yrange [0:1]
set xlabel "The x^{th} message has been processed (either delivered or lost)"
set ylabel "Avg. delivery rate on the window (x-10^3..x)"
unset grid
plot 
END

chomp $plot; my $i = 1;
for (@intervals) {
#	$plot .= "\"$_/$name\" u 1:2 smooth sbezier with lines lc $i lw $size t \"$1\", ";
	$plot .= "\"${_}.data\" u 1:3 with lines lt $i t \"Switch every $_ msg\", ";
	$i++;
}
#$plot .= "\"$_/$name\" u 1:2 with lines lw $size t \"$_\", " for @datadirs;
$plot =~ s/,\s+$//;

open($GNUPLOT,"| gnuplot");
print $plot;
print $GNUPLOT $plot;
close($GNUPLOT);
