my $plot = <<END3;
#!/usr/bin/gnuplot
set output "DR_stack10.svg"
set title "Delivery Rate Classes"
set term svg enhanced size 1000 400
set style data histograms
set style fill solid 1.0 border -1
set style histogram rowstacked
set boxwidth 0.5 relative
set datafile missing '-'
set yrange [0:1.1]
set key  rmargin
unset grid
set xtics nomirror  scale 1
plot
END3

chomp $plot;

$i=1;
$plot .= 
    "\"classes10.data\" u 2:xticlabel(1) lc rgb(\"#0F0000\") t \"0 %\", ".
    "''  u 3 t \"0 - 10 % \" lc rgb(\"#2F0000\"),".
    "''  u 4 t \"10 % - 20 %\" lc rgb(\"#4F0000\"),".
    "''  u 5 t \"20 % - 30 %\" lc rgb(\"#6F0000\"),".
    "''  u 6 t \"30 % - 40 %\" lc rgb(\"#7F0000\"),".
    "''  u 7 t \"40 % - 50 %\" lc rgb(\"#6F2200\"),".
    "''  u 8 t \"50 % - 60 %\" lc rgb(\"#4F4400\"),".
    "''  u 9 t \"60 % - 70 %\" lc rgb(\"#2F6600\"),".
    "''  u 10 t \"70 % - 80 %\" lc rgb(\"#0F8800\"),".
    "''  u 11 t \"80 % - 90 %\" lc rgb(\"#00AA00\"),".
    "''  u 12 t \"90 % - 100 %\" lc rgb(\"#00CC00\"),".
    "''  u 13 t \"100%\" lc rgb(\"#00EE00\"),".
"\"glob.data\" u 2  with points ps 1.3 lt 5 pt 7 lc rgb(\"white\") notitle ,".
"\"glob.data\" u 2  with points ps 1.3 lt 5 pt 6 lc rgb(\"black\") t \"Average Delivery Rate\";" ;



open($GNUPLOT,"| gnuplot");
print $GNUPLOT $plot."\n";
close($GNUPLOT);



