# Heatmap.pl
#
# From classes10.data built by a simulation, does a
# bit of gnuplot dark magic to make a nice EPS of
# the density of nodes in each class. Classes10.data
# must be in ./ , output in heatmap.eps
#
# Quirks :
# - Does not work with anything else than EPS
#
# - When this eps file goes through epspdf, the
# resulting pdf will have graduations that
# can only be seen when printing.
#
# rjamet, 7/10/12

my %data;
my @ALGOS;
open(my $fd, shift) or die("This needs a classes10.data file, get it from a simulation or a grouper");
while(<$fd>) {
	if (s/^\s*([^\s]+)\s*//) {
		my $alg = $1;
		while($alg =~ s/^(WH|SY|SF)-// || $alg =~ s/^\d+-//) {}
		push @ALGOS, $alg;
		$data{$alg} = [];
		while(s/^\s*([^\s]+)\s*//) {
			push @{$data{$alg}}, $1;
		}
	} else { die() }
}
close($fd);

open($fd, ">", "temp.data") or die();

$data{$_}->[1] += $data{$_}->[0] for (keys %data);
$data{$_}->[10] += $data{$_}->[11] for (keys %data);

for my $c (1..10) {
	print $fd "0 $c ";
	for my $alg (@ALGOS) {
		print $fd "".$data{$alg}->[$c]." ";
	}
	print $fd "\n";
}
print $fd "\n";


	
for my $c (1..10) {
	print $fd "1 $c ";
	for my $alg (@ALGOS) {
		print $fd "".$data{$alg}->[$c]." ";
	}
	print $fd "\n";
}
close($fd);


my $nb_plot = keys %data;
my $per_algo = "";
$per_algo .= "\nset xlabel \"algo$_\"; plot 'temp.data' u 1:2:".($_+2)." with image notitle;\n" for (1..$nb_plot);



my $plot = <<END3;
#!/usr/bin/gnuplot
set output "h.eps"

set palette model RGB
set palette model RGB defined (0 "white", 1 "black")
set term postscript eps enhanced size 7,3 16
#set term png size 1000 400
unset view
set yrange [0.5:10.5]
set xrange [0:1]


set cbrange [0:1]
#set ylabel "Proportion of nodes in this class"

unset grid
unset xtics 
set multiplot layout 1,$nb_plot

unset colorbox;
set rmargin 1.2;
set ytics ("0" 0.5, "10" 1.5, "20" 2.5, "30" 3.5, "40" 4.5, "50" 5.5, "60" 6.5, "70" 7.5, "80" 8.5, "90" 9.5, "100" 10.5)

$per_algo

unset multiplot

END3

my $i = 1;
for (@ALGOS) {
	/(.+)/;
	$name = $1;
	$plot=~s/algo$i/$name/;
	$i++
}


open($GNUPLOT,"| gnuplot");
print $GNUPLOT $plot."\n";
close($GNUPLOT);

