#!/usr/bin/perl
use List::Util qw/max/;
use JSON::XS;
srand;

my $term = "set term postscript enhanced eps monochrome size 7,3 18";

 
#parse input
my @datadirs;
my $d;
while($d = shift){
	push(@datadirs,$d);
}




#plots
$name = "de_tb.data";
my $size = 5.0 / max(5,(scalar @datadirs / 5)); 
if (@datadirs > 15) {
	$key = "unset key";
} else {
	$key = "set key rmargin ";
}

my $plot = <<END; 
#!/usr/bin/gnuplot
set output "delivery.eps"

$term

set pointsize 1.8
$key
#set samples 1000
set xrange [0:]
set yrange [0:1]
set format x "%3g"
set xlabel "The x^{th} message has been processed"
set ylabel "Average delivery rate of messages ]x-(5.10^3)..x]"
unset grid
plot 
END

chomp $plot; my $i = 1;
my @legend=(1,5,6);

for (@datadirs) {
	$_ =~ /L(\d+)_/;

	`cat $_/$name | perl shrink.pl 10 > data$1`;

	#DOTS ALONG LINE
#	$plot .= "\"$_/$name\" u 1:2 smooth bezier with linespoints pi -5 ps 1.8 lw $size t \"$1\", ";
	$plot .= "\"data$1\" u 1:3 with linespoints pi -5 ps 1.8 lc rgb('black') lw $size pt ".(shift @legend)." t \"List size $1\", ";

	#RAW LINE
	#$plot .= "\"$_/$name\" u 1:2 with linespoints ps 1.5 lc rgb('black') lt $i lw $size t \"$1\", ";


#	$plot .= "\"$_/$name\" u 1:2 with lines lc $i lw 0.1 notitle, ";
#	$plot .= "\"$_/$name\" u 1:2 with points ps 0.1 pt 7 lc $i notitle, ";
	$i++;
}
#$plot .= "\"$_/$name\" u 1:2 with lines lw $size t \"$_\", " for @datadirs;
$plot =~ s/,\s+$//;

open($GNUPLOT,"| gnuplot");
print $plot;
print $GNUPLOT $plot;
close($GNUPLOT);
