#!/usr/bin/perl
use Data::Dumper;

my %D;
my @ALGOS = qw/TLCNS RW GFG GBR PGBR PRGBR PRDGBR/; 
my @NBNODES = map {$_ * 50} (1..8);

my $grouped_results_dir = "../grouped_results";
my $plotted_3d_results_dir = "../3d_results";

print "Cleaning the repertory $plotted_3d_results_dir\n";
`rm -rf $plotted_3d_results_dir/*`;

print "Transformation of the data\n";
for my $nbnodes (@NBNODES) {
	for my $deg (8,16,32) {
		for my $attk (0, 10, 20, 30) {
			for my $alg (@ALGOS) {
		
				my $rep = "$grouped_results_dir/$nbnodes-$deg-$attk";
				
				open (my $data, "$rep/glob.data") or die("Can't read $rep/glob.data : $!");
				while(<$data>) {
					if (/$alg (\d+(\.\d+)?) /) {
						#DR : $1
						$D{"$nbnodes-$deg-$attk-$alg"} = $1;
					}	
				}	
				close $data;
	
			}
		}
		
	}
}


print "Writing the transformed stuff in $plotted_3d_results\n";
for my $alg (@ALGOS) {
	`mkdir -p $plotted_3d_results_dir/$alg`;
	for my $attk (0, 10, 20, 30) {
		`mkdir $plotted_3d_results_dir/$alg/$attk`;
		open (my $data, ">", "$plotted_3d_results_dir/$alg/$attk/data.txt") or die("Can't open $plotted_3d_results_dir/$alg/$attk/data.txt : $!");
		for my $deg (8,16,32) {#x coord in gnuplot
			for my $nbnodes (@NBNODES) { #y coord in gnuplot
				print $data "$deg $nbnodes ".$D{"$nbnodes-$deg-$attk-$alg"}."\n";
			}
			#gnuplot splot requires newlines to make grids			
			print $data "\n";
		}
		close $data;
	}
}

print "Invoking gnuplot\n";
`cp ../hacks/plot3D.plot $plotted_3d_results_dir && cd $plotted_3d_results_dir && mkdir -p plots && gnuplot plot3D.plot && rm plot3D.plot`;

print("All plotted, it seems. Results in sinalgo/tools/3d_results/.\n");

#print Dumper(\%D);
