#!/usr/bin/perl
my @ALGOS = qw/SR3/;

my $srcdir      = "../grouped_results";;
my $destplotdir = "./plots/slices_ackdet";
my $destdatadir = "./data/slices_ackdet";


`rm -rf $destdatadir && mkdir -p $destdatadir`;
`mkdir -p $destplotdir`;

for my $deg (8) {
for my $nbn (200) {
for my $r (1..10) {
		my $data = `grep -P "ACK-${r}-" $srcdir/${nbn}-${deg}-ACK/glob.data`;
		chomp $data; 
		$data =~ /^.+\s.+\s.+\s(.+)\s.+$/ or ((print "Faulty data :".$data."\n") && next);
		`echo "${r} $1" >> $destdatadir/dr-d${deg}-n${nbn}.data`;
}

my $plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_${deg}_${nbn}.svg"
set title "ACK acceptance rate"
set term svg enhanced size 800 400
set grid
set yrange [0:1]
#set logscale y
set xrange [0:10]
plot \\
END2

	for my $alg (@ALGOS) {
		    $plot .="'${destdatadir}/dr-d${deg}-n${nbn}.data' u 1:2 w linespoints t '$alg', ";
	}
	$plot =~ s/,\s*$/;/;

	print $plot;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);

$plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_${deg}_${nbn}.eps"
set term postscript eps monochrome enhanced size 7,3 18
unset grid
set yrange [0.9:1]
set xrange [1:9]
set xtics 1,1
set clip two
#set logscale y
set ylabel "Accepted acknowledgments proportion"
set xlabel "Size of L_{Ack}"
set key rmargin
plot \\
END2

	my $i = 0;
	for my $alg (@ALGOS) {
				$i++;
		    $plot .="'${destdatadir}/dr-d${deg}-n${nbn}.data' u 1:2 w linespoints lc rgb('black') ps 1.8 lt $i t '$alg',".
								" 0.99  w lines lc rgb('black') lt ".($i+1)." t '99\%',";
	}
	$plot =~ s/,\s*$/;/;

	print $plot;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);



}
}
