#!/usr/bin/perl

my $eps = 1;

my @ALGOS = qw/GFG GBR RGBR PRGBR PRDGBR RW SR3/; 

my $srcdir = "../grouped_results";
my $destplotdir = "./plots/slices_per_nbnodes";
my $destdatadir = "./data/slices_per_nbnodes";


`rm -rf $destdatadir && mkdir -p $destdatadir`;
`mkdir -p $destplotdir`;


for my $deg (qw/ 8 12 16 20 24 28 32/) {
	for my $alg (@ALGOS) {
		my $data = `grep -P "^200-$deg-30-${alg}" $srcdir/200-$deg-30/glob.data`;
		$data =~ /^.+\s(.+)\s.+\s.+\s.+\s.+$/ or next; #beurk
		`echo "$deg $1" >> $destdatadir/${alg}.data`;
	}
}


	my $plot = <<END2;
#!/usr/bin/gnuplot
set title "Delivery rate in presence of black holes"
set output "$destplotdir/DR_deg.eps"
set term postscript eps enhanced size 7,3 18
unset grid
set yrange [0:1]
#set logscale y
set xrange [8:32]
set ylabel "Average delivery rate"
set xlabel "Degree"
set key rmargin
plot \\
END2
	for my $alg (@ALGOS) {
		my $alg2 = $alg;
		$alg2 =~ s/^PGBR$/RGBR/;

		$plot .= "'$destdatadir/".$alg.".data' u 1:2 w linespoints t '$alg2' ps 1.8, "
	}
	$plot =~ s/,\s*$/;/;



	print $plot;
	
        open($GNUPLOT,"| gnuplot");
        print $GNUPLOT $plot."\n";
        close($GNUPLOT);


	


