#!/usr/bin/perl
my @ALGOS =  qw/GFG GBR RGBR PRGBR PRDGBR RW SR3/;

my $srcdir      = "../grouped_results";
my $destplotdir = "./plots/slices_per_degree";
my $destdatadir = "./data/slices_per_degree";

`rm -rf $destdatadir && mkdir -p $destdatadir`;
`mkdir -p $destplotdir`;

for my $deg (8,16,32) {
for my $pct (10,20,30) {
#for my $deg (8,32) {
#for my $pct (20) {

for my $nbn (map {$_ * 50} (1..8)) {
#for my $nbn (map {$_ * 100} (1..4)) {
	for my $alg (@ALGOS) {
		my $data = `grep -P "${nbn}-${deg}-${pct}-${alg}" $srcdir/${nbn}-${deg}-${pct}/glob.data`;
		chomp $data; 
		$data =~ /^.+\s(.+)\s.+\s.+\s.+\s.+$/ or ((print "Faulty data :".$data."\n") && last);
		`echo "${nbn} $1" >> $destdatadir/dr-a${pct}-d${deg}-${alg}.data`;
	}
}


my $plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_${deg}_${pct}.svg"
set title "Delivery rate"
set term svg enhanced size 800 400
set grid
set yrange [0:1]
#set logscale y
set xrange [0:500]
plot \\
END2

	for my $alg (@ALGOS) {
		    $plot .="'${destdatadir}/dr-a${pct}-d${deg}-${alg}.data' u 1:2 w linespoints t '$alg', ";
	}
	$plot =~ s/,\s*$/;/;

	print $plot;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);

$plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_${deg}_${pct}.eps"
set term postscript eps enhanced size 7,3 18
unset grid
set yrange [0:1]
#set logscale y
set xrange [50:400]
set ylabel "Average delivery rate"
set xlabel "Number of nodes"
set key rmargin
plot \\
END2

	my $i = 0;
	for my $alg (@ALGOS) {
				$i++;
		    $plot .="'${destdatadir}/dr-a${pct}-d${deg}-${alg}.data' u 1:2 w linespoints ps 1.8 lc rgb('black') lt $i t '$alg' , ";
	}
	$plot =~ s/,\s*$/;/;

	print $plot;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);



}
}
