#!/usr/bin/perl
my @ALGOS = qw/GFG GBR RGBR PRGBR PRDGBR RW SR3/;

my $srcdir      = "../grouped_results";
my $destplotdir = "./plots/slices_hops";
my $destdatadir = "./data/slices_hops";

`rm -rf $destdatadir && mkdir -p $destdatadir`;
`mkdir -p $destplotdir`;

for my $deg (8,16,32) {

for my $nbn (map {$_ * 50} (1..8)) {
	for my $alg (@ALGOS) {
		my $data = `grep -P "${nbn}-${deg}-0-${alg}\\s" $srcdir/${nbn}-${deg}-0/glob.data`;
		print $data;
		chomp $data; 
		$data =~ /^.+\s.+\s(.+)\s.+\s.+\s(.+)$/; # or next;#($data);		
		`echo "${nbn} $1 $2" >> $destdatadir/nbh-d${deg}-${alg}.data`;
	}
}


my $plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/NBHOPS_$deg.svg"
set title "Number of hops"
set term svg enhanced size 800 400
set grid
set yrange [0:70]
#set logscale y
set xrange [0:500]
plot \\
END2

	for my $alg (@ALGOS) {
		    $plot .="'$destdatadir/nbh-d${deg}-${alg}.data' u 1:2 w linespoints t '$alg', ";
	}
	$plot =~ s/,\s*$/;/;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);

$plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/NBHOPS_${deg}.eps"
set term postscript eps monochrome enhanced size 7,3 18
unset grid
set yrange [0:25]
#set logscale y
set xrange [50:400]
set ylabel "Average number of hops"
set xlabel "Number of nodes"
set key rmargin
plot \\
END2

	my $i = 0;
	for my $alg (@ALGOS) {
		$i++;
		$plot .="'${destdatadir}/nbh-d${deg}-${alg}.data' u 1:2 w linespoints lc rgb('black') ps 1.8 lt $i t '$alg', ";
	}
	$plot =~ s/,\s*$/;/;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);




}
