#!/usr/bin/perl
my @ALGOS = qw/GFG GBR PGBR PRGBR PRDGBR RW SR3/; # SR31overR/;

my $srcdir      = "../grouped_results";
my $destplotdir = "./plots/slices_per_degree";
my $destdatadir = "./data/slices_per_degree";

`rm -rf $destdatadir && mkdir -p $destdatadir`;
`mkdir -p $destplotdir`;


for my $nbn (200) {
for my $deg (map {$_*4} (2..10)) {
	for my $alg (@ALGOS) {
		my $data = `grep -P "${nbn}-${deg}-0-${alg} " $srcdir/${nbn}-${deg}-0/glob.data`;
		print $data;
		chomp $data; 
		$data =~ /^.+\s.+\s(.+)\s.+\s.+\s(.+)$/ or next;
		my $cmd = "echo \"${deg} $1 $2\" >> $destdatadir/nbh-200-${alg}.data";
		`$cmd`;
	}
}


my $plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/NBHOPS_200.svg"
set title "Number of hops"
set term svg enhanced size 800 400
set grid
set yrange [0:70]
#set logscale y
set xrange [8:40]
plot \\
END2

	for my $alg (@ALGOS) {
		    $plot .="'$destdatadir/nbh-200-${alg}.data' u 1:2 w linespoints t '$alg', ";
	}
	$plot =~ s/,\s*$/;/;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);

$plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/NBHOPS_200.eps"
set term postscript eps monochrome enhanced size 7,3 18
unset grid
set yrange [0:10]
#set logscale y
set xrange [8:40]
set xtics 8,4
set ytics 0,1
set ylabel "Average route expansion factor"
set xlabel "Average degree"
set key rmargin
plot \\
END2

	my $i = 0;
	for my $alg (@ALGOS) {
		$i++;
		$plot .= "'${destdatadir}/nbh-200-${alg}.data' u 1:3 w linespoints lc rgb('black') ps 1.8 lt $i t '$alg', ";

	}
	$plot =~ s/,\s*$/;/;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);




}
