#!/usr/bin/perl
my @ALGOS = qw/SR3/;

my $srcdir      = "../grouped_results";
my $destplotdir = "./plots/slices_route";
my $destdatadir = "./data/slices_route";


#`rm -rf $destdatadir && mkdir -p $destdatadir`;
`mkdir -p $destplotdir`;

for my $deg (8,16,32) {
for my $nbn (100,200,400) {
if (0) {
for my $r (1..40) {
		my $data = `grep -P "ROUTE-$r-" $srcdir/${nbn}-${deg}-ROUTE/glob.data`;
		chomp $data; 
		$data =~ /^.+\s(.+)\s.+\s.+\s.+$/ or ((print "Faulty data :".$data."\n") && next);
		`echo "${r} $1" >> $destdatadir/dr-d${deg}-n${nbn}.data`;
}
}

my $plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_${deg}_${nbn}.svg"
set title "Delivery rate"
set term svg enhanced size 800 400
set grid
set yrange [0:1]
#set logscale y
set xrange [0:500]
plot \\
END2

	for my $alg (@ALGOS) {
		    $plot .="'${destdatadir}/dr-d${deg}-n${nbn}.data' u 1:2 w linespoints t '$alg', ";
	}
	$plot =~ s/,\s*$/;/;

	print $plot;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);

$plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_${deg}_${nbn}.eps"
set term postscript eps monochrome enhanced size 7,3 18
unset grid
set yrange [0.4:0.8]
set xrange [1:40]
set clip two
#set logscale y
set ylabel "Average delivery rate"
set xlabel "Size of Lrouting"
set key rmargin
plot \\
END2

	my $i = 0;
	for my $alg (@ALGOS) {
				$i++;
		    $plot .="'${destdatadir}/dr-d${deg}-n${nbn}.data' u 1:2 w linespoints lc rgb('black') ps 1.8 lt $i t '$alg',  '${destdatadir}/dr-best.data' u 1:2 w linespoints lc rgb('black') ps 1.8 lt ".($i+1)." t 'Best', ";
	}
	$plot =~ s/,\s*$/;/;

	print $plot;

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);



}
}
