#!/usr/bin/perl
my @ALGOS = qw/GFG GBR RGBR PRGBR PRDGBR RW SR3/; 


my $srcdir = "../grouped_results";
my $destplotdir = "./plots/slices_sf";
my $destdatadir = "./data/slices_sf";


`rm -rf $destdatadir; mkdir -p $destdatadir`;
`mkdir -p $destplotdir`;

for my $pct (map {$_*10} 0..10) {
	for my $alg (@ALGOS) {
			
			my $data = `grep -P "^SF-${alg}-$pct " $srcdir/SF*/glob.data`;
			$data =~ /^.+\s(.+)\s.+\s.+\s.+\s.+$/ or next; #beurk
			`echo "$pct $1" >> $destdatadir/${alg}.data`;
	}
}

	
	my $plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_SF.svg"
set title "Delivery rate in presence of SF intruders"
set term svg enhanced size 800 400
set grid
set yrange [0:1]
set xrange [0:140]
set xlabel "Proportion of intercepted messages"
plot \\
END2
	for my $alg (@ALGOS) {
		$plot .= "'$destdatadir/".$alg.".data' u 1:2 w linespoints t '$alg', "
	}
	$plot =~ s/,\s*$/;/;

	print $plot;
	
        open($GNUPLOT,"| gnuplot");
        print $GNUPLOT $plot."\n";
        close($GNUPLOT);
	


$plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_SF.eps"
set term postscript eps monochrome enhanced size 7,3 18
unset grid
set yrange [0:1]
set xrange [0:100]
set ylabel "Average delivery rate"
set xlabel "Proportion of intercepted messages"
set key rmargin
plot \\
END2

	my $i = 0;
	for my $alg (@ALGOS) {
		$i++;
		$plot .="'${destdatadir}/${alg}.data' u 1:2 w linespoints lc rgb('black') ps 1.8 lt $i t '$alg', ";
	}
	$plot =~ s/,\s*$/;/;

	print $plot."\n";

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);


