#!/usr/bin/perl
my @ALGOS = sort qw/SR3 SIGF SIGFA GFG/; 


my $srcdir = "../grouped_results";
my $destplotdir = "./plots/slices_sigf";
my $destdatadir = "./data/slices_sigf";
`rm -r $destdatadir`;
`mkdir -p $destdatadir`; 
`mkdir -p $destplotdir`; 


for my $pct (10, 20, 30) {
	for my $alg (@ALGOS) {
		my $data = `grep -P "${alg} " $srcdir/200-16-$pct/glob.data`;
		$data =~ /^.+\s(.+)\s.+\s.+\s.+\s.+$/ or die($data); #beurk
		`echo "$pct $1" >> $destdatadir/${alg}.data`;
	}
}

	
	my $plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_SIGF.svg"
set title "Delivery rate"
set term svg enhanced size 800 400
set grid
set yrange [0:1]
set xrange [0:40]
set xlabel "Attacker percentage"
plot \\
END2
	for my $alg (@ALGOS) {
		$plot .= "'$destdatadir/".$alg.".data' u 1:2 w linespoints t '$alg', "
	}
	$plot =~ s/,\s*$/;/;

	print $plot;
	
        open($GNUPLOT,"| gnuplot");
        print $GNUPLOT $plot."\n";
        close($GNUPLOT);


	
$plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_SIGF.eps"
set term postscript eps monochrome enhanced size 7,3 18
unset grid
set yrange [0:1]
set xrange [5:35]
set xtics 10,10
set ylabel "Average delivery rate"
set xlabel "Percentage of attackers in the network"
set key rmargin
plot \\
END2

	my $i = 0;
	for my $alg (@ALGOS) {
		$i++;
		$plot .="'${destdatadir}/${alg}.data' u 1:2 w linespoints lc rgb('black') ps 1.8 lt $i ";
		if ($alg eq "SIGFA") {
			$plot .= "t 'SIGF vs. SBH', ";
		} else {
			$plot .= "t '$alg vs. BH', ";
		}
	}
	$plot =~ s/,\s*$/;/;

	print $plot."\n";

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);


	


