#!/usr/bin/perl
my @SWITCHRATES = map {100*$_} (1,2,4,8,16,32,64,128,256,512,1024);


my $srcdir = "../grouped_results";
my $destplotdir = "./plots/slices_whswitch";
my $destdatadir = "./data/slices_whswitch";

`rm -rf $destdatadir && mkdir -p $destdatadir`;
`mkdir -p $destplotdir`;

for my $sw (@SWITCHRATES) {
		my $data = `grep -P "^WHSWITCH-$sw" $srcdir/WHSWITCH/glob.data`;
		$data =~ /^.+\s(.+)\s.+\s.+\s.+\s.+$/ or next; #beurk
		`echo "$sw $1" >> $destdatadir/SR3.data`;
}

	
	my $plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_WHSW.svg"
set title "Delivery rate in presence of WH/BH intruders"
set term svg enhanced size 800 400
set grid
set yrange [0:1]
set xrange [50:204800]
set xtics 50,2,204800
unset xmtics
set logscale x
set xlabel "Number of packets before switch of behaviour"
plot "$destdatadir/SR3.data" u 1:2 w linespoints t 'SR3'
END2

	print $plot;
	
        open($GNUPLOT,"| gnuplot");
        print $GNUPLOT $plot."\n";
        close($GNUPLOT);


	
$plot = <<END2;
#!/usr/bin/gnuplot
set output "$destplotdir/DR_WHSW.eps"
set term postscript eps monochrome enhanced size 7,3 18
unset grid
set yrange [0.7:1]
set xrange [50:204800]
set ylabel "Average delivery rate"
set xlabel "Number of packets before switching behaviour"
set xtics 50,2,204800
set logscale x
set key rmargin
plot \\
END2

		$plot .="'${destdatadir}/SR3.data' u 1:2 w linespoints lc rgb('black') ps 1.8 lt 1 t 'SR3' ";

	print $plot."\n";

	open( $GNUPLOT, "| gnuplot" );
	print $GNUPLOT $plot . "\n";
	close($GNUPLOT);


